DECLARE SUB BeregnFliser ()
DECLARE SUB VisSomFelter ()
DECLARE FUNCTION HentBSVFilnavne$ (Efternavn$)
DECLARE FUNCTION NaermesteFarve! (Roed%, Groen%, Blaa%)
DECLARE SUB VisBSVFil (FilNavn$)
DECLARE SUB MenuPunktValgt (Soejle%, MenuValg%)
DECLARE SUB SkrivMusePosition (X%, Y%)
DECLARE SUB VentPaaMuseSlip ()
DECLARE SUB FlytValgtOmraade ()
DECLARE SUB GemMaske (FilNavn$)
DECLARE SUB NyStoerrelse (Nybredde%, NyHoejde%)
DECLARE SUB TegnValgtOmraade (X%, Y%)
DECLARE SUB HentBSV ()
DECLARE FUNCTION HentFilnavne$ (Efternavn$)
DECLARE FUNCTION HentBSVFilnavnetemp$ (Efternavn$)
DECLARE SUB Besked (Tekst$, Tekst2$, Farve%, tid!)
DECLARE SUB HentBin ()
DECLARE SUB GemBIN (FilNavn$)
DECLARE SUB GemBSV (FilNavn$)
DECLARE FUNCTION JaNejTryk! (Spoergsmaal$)
DECLARE FUNCTION Indtast$ (Spoergsmaal$, TekstEllerTal$, Forslag$)
DECLARE SUB MenuTryk (Soejle%)
DECLARE SUB TegnMenuBjaelke (Soejle%, Raekke%, Valgt%)
DECLARE SUB Fyld (X%, Y%)
DECLARE FUNCTION CheckFelt! (X%, Y%)
DECLARE SUB OpdaterValgtFarve (FarveValgt%)
DECLARE SUB CheckTast (tast$)
DECLARE SUB KnapTryk (KnapTrykket AS INTEGER)
DECLARE SUB TegnFelt (X%, Y%, Farve%)
DECLARE SUB Kasse (XStart%, YStart%, Laengde%, Hoejde%, Farve%)
DECLARE SUB LavSkaerm ()
DECLARE SUB HentFont ()
DECLARE SUB HentPalette (PalettensNavn$)
DECLARE SUB Skriv (Tekst AS STRING, X%, Y%, FontFarve%, Stoerrelse%, Skygge%, tid!)
DECLARE SUB InitVar ()

'************************************************************
'       Over her er der rutiner til programmet
'       Nedenunder er der rutiner til musen
'************************************************************
DECLARE SUB MouseStatus (LB%, RB%, xMouse%, yMouse%)
DECLARE SUB MouseRange (X1%, Y1%, X2%, Y2%)
DECLARE SUB MousePut (X%, Y%)
DECLARE SUB GemMus ()
DECLARE SUB MouseDriver (ax%, bx%, cx%, dx%)
DECLARE SUB VisMus ()
DECLARE SUB HentMuseStatus (LB%, RB%, xMouse%, yMouse%)
DECLARE SUB CheckMus ()
DECLARE SUB InitMus ()
DECLARE FUNCTION MouseInit% ()

TYPE Farvetype
  R AS STRING * 1
  G AS STRING * 1
  B AS STRING * 1
END TYPE

TYPE BilledeType
  Feltstr AS INTEGER
  VenstreMargin AS INTEGER
  TopMargin AS INTEGER
  Beskidt AS STRING * 1
  Xned AS INTEGER        'Husker hvor et valgt omrde blev startet
  Yned AS INTEGER        'Husker hvor et valgt omrde blev startet
  Xop AS INTEGER        'Husker hvor et valgt omrde blev startet
  Yop AS INTEGER        'Husker hvor et valgt omrde blev startet
  Valgigang AS STRING * 1       'Er brugeren ved at vlge?
  ForrigeXfelt AS INTEGER        'Husker de Forrige X og Y pixels i spriten
  ForrigeYfelt AS INTEGER        'som der var valgt til
  FilNavn AS STRING * 8
  Fliser AS STRING * 1           'Tegnes der til fliser (ved siden af hinanden)
  AntaliHoejden AS INTEGER      'Hvor mange fliser kan der vre p 100 pixels
  AntaliBredden AS INTEGER      'Hvor mange fliser kan der vre p 100 pixels
  SamletBredde AS INTEGER       'Hvor meget fylder de i bredden
  SamletHoejde AS INTEGER       'Hvor meget fylder de i hjden
END TYPE

TYPE Musefunktioner
  Funktion AS STRING * 10
  Farve AS INTEGER              'husker hvilken farve musen tegner med
  GamleFarve AS INTEGER         'husker hvilken farve musen sidst tegnede med
END TYPE

TYPE Vaerktoejstype
  FilnavnOppe AS STRING * 12        'Hvilken fil bruges der til knappen
  FilnavnNede AS STRING * 12        'Hvilken fil bruges der til knappen
END TYPE

DIM SHARED Farve(0 TO 255) AS Farvetype, FilNavn(0 TO 299) AS STRING * 12
DIM SHARED Alfabet(0 TO 839) AS STRING * 1, Tabel(8) AS INTEGER
DIM SHARED FontFarve(8) AS INTEGER, mus AS Musefunktioner
DIM SHARED VaerkToej(0 TO 5) AS Vaerktoejstype
DIM SHARED Knapper%(7650)
DIM SHARED Billede AS BilledeType, knap%(10000)
DIM SHARED Menu(0 TO 2, 0 TO 7) AS STRING * 10, Version$

COMMON SHARED pixel AS STRING * 1, pixel2 AS STRING * 1, Mouse$, LB%, RB%
COMMON SHARED Xmus%, Ymus%
COMMON SHARED AktivtVaerktoej AS INTEGER, ValgtOmraade AS STRING * 1

REDIM SHARED Sprite(0 TO 19, 0 TO 19) AS INTEGER
REDIM SHARED HuskeOmraade(0 TO 19, 0 TO 19) AS INTEGER

InitVar
BeregnFliser
InitMus
SCREEN 13
VisBSVFil "xs-edit.bsv"
CLS
HentPalette ""
HentFont
LavSkaerm
VisMus
MouseRange 0, 0, 638, 198
MousePut 100, 100


DO
  HentMuseStatus LB%, RB%, X%, Y%
  CheckMus
  tast$ = INKEY$
  IF LEN(tast$) THEN CheckTast tast$
LOOP

Musedata:
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

PALETTELabel:
DATA    0,   0,   0,   0,   0,  42,   0,  42,   0,   0,  42,  42,  42,   0,   0,  42,   0,  42,  42,  21,   0,  42,  42,  42,  21,  21,  21,  21,  21,  63,  21,  63,  21,  21,  63,  63,  63,  21,  21,  63,  21,  63
DATA   63,  63,  21,  63,  63,  63,  59,  59,  59,  55,  55,  55,  52,  52,  52,  48,  48,  48,  45,  45,  45,  42,  42,  42,  38,  38,  38,  35,  35,  35,  31,  31,  31,  28,  28,  28,  25,  25,  25,  21,  21,  21
DATA   18,  18,  18,  14,  14,  14,  11,  11,  11,   8,   8,   8,  63,   0,   0,  59,   0,   0,  56,   0,   0,  53,   0,   0,  50,   0,   0,  47,   0,   0,  44,   0,   0,  41,   0,   0,  38,   0,   0,  34,   0,   0
DATA   31,   0,   0,  28,   0,   0,  25,   0,   0,  22,   0,   0,  19,   0,   0,  16,   0,   0,  63,  54,  54,  63,  46,  46,  63,  39,  39,  63,  31,  31,  63,  23,  23,  63,  16,  16,  63,   8,   8,  63,   0,   0
DATA   63,  42,  23,  63,  38,  16,  63,  34,   8,  63,  30,   0,  57,  27,   0,  51,  24,   0,  45,  21,   0,  39,  19,   0
DATA   63,  63,  54,  63,  63,  46,  63,  63,  39,  63,  63,  31,  63,  62,  23,  63,  61,  16,  63,  61,   8,  63,  61,   0,  57,  54,   0,  51,  49,   0,  45,  43,   0,  39,  39,   0,  33,  33,   0,  28,  27,   0
DATA   22,  21,   0,  16,  16,   0,  52,  63,  23,  49,  63,  16,  45,  63,   8,  40,  63,   0,  36,  57,   0,  32,  51,   0,  29,  45,   0,  24,  39,   0,  54,  63,  54,  47,  63,  46,  39,  63,  39,  32,  63,  31
DATA   24,  63,  23,  16,  63,  16,   8,  63,   8,   0,  63,   0,   0,  63,   0,   0,  59,   0,   0,  56,   0,   0,  53,   0,   1,  50,   0,   1,  47,   0,   1,  44,   0,   1,  41,   0,   1,  38,   0,   1,  34,   0
DATA    1,  31,   0,   1,  28,   0,   1,  25,   0,   1,  22,   0,   1,  19,   0,   1,  16,   0,  54,  63,  63,  46,  63,  63,  39,  63,  63,  31,  63,  62,  23,  63,  63,  16,  63,  63,   8,  63,  63,   0,  63,  63
DATA    0,  57,  57,   0,  51,  51,   0,  45,  45,   0,  39,  39,   0,  33,  33,   0,  28,  28,   0,  22,  22,   0,  16,  16
DATA   23,  47,  63,  16,  44,  63,   8,  42,  63,   0,  39,  63,   0,  35,  57,   0,  31,  51,   0,  27,  45,   0,  23,  39,  54,  54,  63,  46,  47,  63,  39,  39,  63,  31,  32,  63,  23,  24,  63,  16,  16,  63
DATA    8,   9,  63,   0,   1,  63,   0,   0,  63,   0,   0,  59,   0,   0,  56,   0,   0,  53,   0,   0,  50,   0,   0,  47,   0,   0,  44,   0,   0,  41,   0,   0,  38,   0,   0,  34,   0,   0,  31,   0,   0,  28
DATA    0,   0,  25,   0,   0,  22,   0,   0,  19,   0,   0,  16,  60,  54,  63,  57,  46,  63,  54,  39,  63,  52,  31,  63,  50,  23,  63,  47,  16,  63,  45,   8,  63,  42,   0,  63,  38,   0,  57,  32,   0,  51
DATA   29,   0,  45,  24,   0,  39,  20,   0,  33,  17,   0,  28,  13,   0,  22,  10,   0,  16,  63,  54,  63,  63,  46,  63,  63,  39,  63,  63,  31,  63,  63,  23,  63,  63,  16,  63,  63,   8,  63,  63,   0,  63
DATA   56,   0,  57,  50,   0,  51,  45,   0,  45,  39,   0,  39,  33,   0,  33,  27,   0,  28,  22,   0,  22,  16,   0,  16
DATA   63,  58,  55,  63,  56,  52,  63,  54,  49,  63,  53,  47,  63,  51,  44,  63,  49,  41,  63,  47,  39,  63,  46,  36,  63,  44,  32,  63,  41,  28,  63,  39,  24,  60,  37,  23,  58,  35,  22,  55,  34,  21
DATA   52,  32,  20,  50,  31,  19,  47,  30,  18,  45,  28,  17,  42,  26,  16,  40,  25,  15,  39,  24,  14,  36,  23,  13,  34,  22,  12,  32,  20,  11,  29,  19,  10,  27,  18,   9,  23,  16,   8,  21,  15,   7
DATA   18,  14,   6,  16,  12,   6,  14,  11,   5,  10,   8,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  49,  10,  10,  49,  19,  10
DATA   49,  29,  10,  49,  39,  10,  49,  49,  10,  39,  49,  10,  29,  49,  10,  19,  49,  10,  10,  49,  12,  10,  49,  23,  10,  49,  34,  10,  49,  45,  10,  42,  49,  10,  31,  49,  10,  20,  49,  11,  10,  49
DATA   22,  10,  49,  33,  10,  49,  44,  10,  49,  49,  10,  43,  49,  10,  32,  49,  10,  21,  49,  10,  10,  63,  63,  63

'Dette er data til fonten - m ikke fjernes eller ndres
Font:
DATA    0 ,   2 ,  47 ,  47 ,   2 ,   0 ,   0 ,   3 ,   0 ,   3 ,   0 ,   0 ,  20 ,  62 ,  20 ,  62 ,  20 ,   0 ,  36 ,  42 , 107 ,  42 ,  16 ,   0 ,  32 ,  18 ,   8 ,   4 ,  34 ,   0 ,  60 ,  38 ,  41 ,  23 ,  32 ,   0 ,   0 ,   0 ,   4 ,   3
DATA    0 ,   0 ,  12 ,  30 ,  33 ,   0 ,   0 ,   0 ,   0 ,   0 ,  33 ,  30 ,  12 ,   0 ,  42 ,  28 ,  62 ,  28 ,  42 ,   0 ,   0 ,   8 ,  28 ,   8 ,   0 ,   0 ,   0 ,   0 ,  64 ,  48 ,   0 ,   0 ,   0 ,   8 ,   8 ,   8 ,   8 ,   0 ,   0 ,   0
DATA    0 ,  32 ,   0 ,   0 ,  32 ,  16 ,   8 ,   4 ,   2 ,   0 ,  30 ,  33 ,  33 ,  33 ,  30 ,   0 ,   0 ,  34 ,  63 ,  32 ,   0 ,   0 ,  34 ,  49 ,  49 ,  41 ,  38 ,   0 ,  18 ,  33 ,  37 ,  37 ,  26 ,   0 ,   8 ,  12 ,  10 ,  63 ,   8 ,   0
DATA   23 ,  37 ,  37 ,  37 ,  25 ,   0 ,  30 ,  37 ,  37 ,  37 ,  24 ,   0 ,   3 ,   1 ,  49 ,   9 ,   7 ,   0 ,  26 ,  37 ,  37 ,  37 ,  26 ,   0 ,   6 ,  41 ,  41 ,  41 ,  30 ,   0 ,   0 ,   0 ,  20 ,   0 ,   0 ,   0 ,   0 ,  64 ,  52 ,   0
DATA    0 ,   0 ,   8 ,  20 ,  34 ,  65 ,   0 ,   0 ,   0 ,  20 ,  20 ,  20 ,   0 ,   0 ,   0 ,  65 ,  34 ,  20 ,   8 ,   0 ,   6 ,   1 ,  81 ,   9 ,   6 ,   0 ,  30 ,  33 ,  45 ,  45 ,  14 ,   0 ,  60 ,  10 ,   9 ,  10 ,  60 ,   0 ,  63 ,  37
DATA   37 ,  37 ,  26 ,   0 ,  30 ,  33 ,  33 ,  33 ,  18 ,   0 ,  63 ,  33 ,  33 ,  33 ,  30 ,   0 ,  63 ,  41 ,  41 ,  33 ,  33 ,   0 ,  63 ,   9 ,   9 ,   1 ,   1 ,   0 ,  30 ,  33 ,  33 ,  41 ,  26 ,   0 ,  63 ,   8 ,   8 ,   8 ,  63 ,   0
DATA    0 ,  33 ,  63 ,  33 ,   0 ,   0 ,  16 ,  33 ,  33 ,  33 ,  31 ,   0 ,  63 ,  12 ,  12 ,  18 ,  33 ,   0 ,  63 ,  32 ,  32 ,  32 ,  32 ,   0 ,  63 ,   2 ,   4 ,   2 ,  63 ,   0 ,  63 ,   2 ,   4 ,   8 ,  63 ,   0 ,  30 ,  33 ,  33 ,  33
DATA   30 ,   0 ,  63 ,   9 ,   9 ,   9 ,   6 ,   0 ,  30 ,  33 ,  41 ,  17 ,  46 ,   0 ,  63 ,   9 ,   9 ,  25 ,  38 ,   0 ,  34 ,  37 ,  37 ,  37 ,  24 ,   0 ,   1 ,   1 ,  63 ,   1 ,   1 ,   0 ,  31 ,  32 ,  32 ,  32 ,  31 ,   0 ,  15 ,  16
DATA   32 ,  16 ,  15 ,   0 ,  31 ,  32 ,  24 ,  32 ,  31 ,   0 ,  33 ,  18 ,  12 ,  18 ,  33 ,   0 ,   3 ,   4 ,  56 ,   4 ,   3 ,   0 ,  33 ,  49 ,  41 ,  37 ,  35 ,   0 ,   0 ,   0 ,  63 ,  33 ,   0 ,   0 ,   3 ,   6 ,  12 ,  24 ,  48 ,   0
DATA    0 ,  33 ,  63 ,   0 ,   0 ,   0 ,   0 ,   2 ,   1 ,   2 ,   0 ,   0 ,   0 ,  64 ,  64 ,  64 ,  64 ,   0 ,   0 ,   0 ,   1 ,   2 ,   0 ,   0 ,   0 ,  16 ,  42 ,  42 ,  60 ,   0 ,   0 ,  63 ,  34 ,  34 ,  28 ,   0 ,   0 ,  28 ,  34 ,  34
DATA   34 ,   0 ,   0 ,  28 ,  34 ,  34 ,  63 ,   0 ,   0 ,  28 ,  42 ,  42 ,  44 ,   0 ,   0 ,   8 ,  62 ,   9 ,   2 ,   0 ,   0 , 156 , 162 , 162 , 126 ,   0 ,   0 ,  63 ,   2 ,   2 ,  60 ,   0 ,   0 ,   0 ,  61 ,   0 ,   0 ,   0 ,   0 , 128
DATA  125 ,   0 ,   0 ,   0 ,   0 ,  63 ,   8 ,  52 ,   0 ,   0 ,   0 ,   0 ,  63 ,   0 ,   0 ,   0 ,  62 ,   2 ,  60 ,   2 ,  60 ,   0 ,   0 ,  62 ,   2 ,   2 ,  60 ,   0 ,   0 ,  28 ,  34 ,  34 ,  28 ,   0 ,   0 , 254 ,  34 ,  34 ,  28 ,   0
DATA    0 ,  28 ,  34 ,  34 , 254 ,   0 ,   0 ,   0 ,  60 ,   2 ,   2 ,   0 ,   0 ,  36 ,  42 ,  42 ,  18 ,   0 ,   0 ,   2 ,  31 ,  34 ,   0 ,   0 ,   0 ,  30 ,  32 ,  32 ,  62 ,   0 ,  14 ,  16 ,  32 ,  16 ,  14 ,   0 ,  30 ,  32 ,  24 ,  32
DATA   30 ,   0 ,  34 ,  20 ,   8 ,  20 ,  34 ,   0 ,   0 , 158 , 160 , 160 , 126 ,   0 ,   0 ,  34 ,  50 ,  42 ,  38 ,   0 ,   0 ,   8 ,  62 ,  65 ,  65 ,   0 ,   0 ,   0 ,  63 ,   0 ,   0 ,   0 ,   0 ,  65 ,  65 ,  62 ,   8 ,   0 ,   0 ,   2
DATA    1 ,   2 ,   1 ,   0 ,  56 ,  36 ,  34 ,  36 ,  56 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  56 ,  52 ,  37 ,  41 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  18 ,  43 ,  43 ,  60 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  56 ,  22 ,  21 ,  22 ,  56 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  18 ,  42 ,  28 ,  42 ,  44 ,   0 ,  60 ,  10
DATA   63 ,  41 ,  33 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  25 ,  36 ,  36 ,  25 ,   0 ,   0 ,  24 ,  37 ,  38 ,  24 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  64 ,  60 ,  50 ,  38 ,  30 ,   1 ,   0 ,  42 ,  61 ,  41 ,  34 ,   0 ,  62 ,  41 ,  37 ,  30 ,   1 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  32 ,  23 ,   8 ,  36 ,  54 ,  45 ,  16 ,  11 ,   4 ,  26 ,  17 ,  56

SUB BeregnFliser

Billede.AntaliHoejden% = INT(100 / UBOUND(Sprite, 1))
Billede.AntaliBredden% = INT(100 / UBOUND(Sprite, 2))

Billede.SamletHoejde% = UBOUND(Sprite, 1) * AntaliHoejden%
Billede.SamletBredde% = UBOUND(Sprite, 2) * AntaliBredden%

END SUB

SUB Besked (Tekst$, Tekst2$, Farve%, tid!)

DIM Getter((LEN(Tekst$) * 6 + 20) * 50) AS INTEGER

IF LEN(Tekst$) > LEN(Tekst2$) THEN
  TekstLaengde = LEN(Tekst$)
ELSE
  TekstLaengde = LEN(Tekst2$)
END IF

Xmin% = (320 - (TekstLaengde * 6 + 20)) / 2
Xmax% = Xmin% + (TekstLaengde * 6 + 20)
Ymin% = 70
Ymax% = 100

GET (Xmin%, Ymin%)-(Xmax%, Ymax%), Getter
LINE (Xmin%, Ymin%)-(Xmax% - 1, Ymax% - 1), 30, BF
LINE (Xmin%, Ymin%)-(Xmax% - 1, Ymax% - 1), 27, B
LINE (Xmin% + 1, Ymin% + 1)-(Xmax% - 2, Ymin% + 1), 31
LINE (Xmin% + 1, Ymin% + 1)-STEP(0, 27), 31
LINE (Xmin% + 1, Ymax%)-(Xmax%, Ymax%), 31
LINE (Xmax%, Ymin% + 1)-STEP(0, 28), 31


IF LEN(Tekst2$) THEN
  Skriv Tekst$, -1, 75, Farve%, 1, 1, 0
  Skriv Tekst2$, -1, 88, Farve%, 1, 1, 0
ELSE
  Skriv Tekst$, -1, 80, Farve%, 1, 1, 0
END IF

WHILE LEN(INKEY$): WEND
starttid! = TIMER
DO
LOOP WHILE TIMER - starttid < tid! AND LEN(INKEY$) = 0

PUT (Xmin%, Ymin%), Getter, PSET
WHILE LEN(INKEY$): WEND
END SUB

FUNCTION CheckFelt (X%, Y%)

IF X% < 0 OR X% > UBOUND(Sprite) - 1 OR Y% < 0 OR Y% > UBOUND(Sprite, 2) - 1 THEN
  CheckFelt = -1
ELSE
  CheckFelt = Sprite(X%, Y%)
END IF
END FUNCTION

SUB CheckMus

IF LB% THEN
  'Hvis der peges p paletten
  IF Xmus% > 62 AND Xmus% < 576 AND Ymus% < 196 AND Ymus% > 180 THEN
    X = (Xmus% - 64) \ 8
    Y = (Ymus% - 180) \ 4
    OpdaterValgtFarve 64 * Y + X
    IF AktivtVaerktoej = 2 THEN 'Hvis det er farvekonverteren
      FOR X% = 0 TO UBOUND(Sprite, 1) - 1
        FOR Y% = 0 TO UBOUND(Sprite, 2) - 1
          IF Sprite(X%, Y%) = mus.GamleFarve THEN
            Sprite(X%, Y%) = mus.Farve
            TegnFelt X%, Y%, mus.Farve
          END IF
        NEXT Y%, X%
        Billede.Beskidt = "T"
    END IF
        'Ellers hvis der peges p tegneomrdet
  ELSEIF Xmus% \ 2 > Billede.VenstreMargin - 1 AND Xmus% \ 2 < Billede.VenstreMargin + Billede.Feltstr * UBOUND(Sprite, 1) AND Ymus% > Billede.TopMargin - 1 AND Ymus% < Billede.TopMargin + Billede.Feltstr * UBOUND(Sprite, 2) THEN
    X% = ((Xmus% \ 2) - Billede.VenstreMargin) \ Billede.Feltstr
    Y% = (Ymus% - Billede.TopMargin) \ Billede.Feltstr
    SkrivMusePosition X%, Y%
    SELECT CASE AktivtVaerktoej
      CASE 0  'priktegner
        IF Sprite(X%, Y%) = mus.Farve THEN EXIT SUB
        Sprite(X%, Y%) = mus.Farve
        GemMus
        TegnFelt X%, Y%, mus.Farve
        VisMus
        Billede.Beskidt = "T"
      CASE 1  'Fyld
        IF Sprite(X%, Y%) = mus.Farve THEN EXIT SUB
        Fyld X%, Y%
        Billede.Beskidt = "T"
      CASE 3, 4, 5 'Vlger
       IF Billede.Valgigang = "F" THEN
         'Overtegner frst det gamle valgte omrde
         GemMus
         FOR XFelt% = Billede.Xned TO Billede.Xop
           FOR YFelt% = Billede.Yned TO Billede.Yop
             IF XFelt% = Billede.Xned OR XFelt% = Billede.Xop OR YFelt% = Billede.Yned OR YFelt% = Billede.Yop THEN TegnFelt XFelt%, YFelt%, Sprite(XFelt%, YFelt%)
         NEXT YFelt%, XFelt%
         Billede.Xned = X%
         Billede.Yned = Y%
         Billede.Valgigang = "T"
         VisMus
       ELSE
         TegnValgtOmraade X%, Y%
         Billede.ForrigeXfelt = X%
         Billede.ForrigeYfelt = Y%
       END IF
    END SELECT
        'Ellers hvis der peges p trykknapperne
  ELSEIF Xmus% > 350 AND Xmus% < 390 AND Ymus% > 20 AND Ymus% < 140 THEN
    KnapTrykket% = (Ymus% - 20) \ 20
    KnapTryk KnapTrykket%

  'Ellers hvis der peges p menuen
  ELSEIF Ymus% < 11 AND Xmus% / 2 < 194 THEN
    TryktKnap% = (Xmus% / 2 - 10) \ 65
    MenuTryk TryktKnap%
 
  'Ellers hvis der peges p PAL knappen
  ELSEIF Xmus% > 585 AND Xmus% < 617 AND Ymus% < 197 AND Ymus% > 179 THEN
    IF JaNejTryk("Vil du hente en ny palette?") = 1 THEN
      PalettensNavn$ = HentFilnavne$("PAL")
      IF LEN(PalettensNavn$) = 0 THEN EXIT SUB
      HentPalette PalettensNavn$
    END IF
  
  'Ellers, hvis der trykkes p TILE knappen
  ELSEIF Xmus% > 397 AND Xmus% < 441 AND Ymus% < 175 AND Ymus% > 154 THEN
    GemMus
    IF Billede.Fliser = "F" THEN
      PUT (200, 155), Knapper%(404 * 7 + 202), PSET
      Billede.Fliser = "T"
      TegnFelt X%, Y%, Sprite(X%, Y%)
    ELSE
      PUT (200, 155), Knapper%(404 * 7), PSET
      Billede.Fliser = "F"
      LINE (200, 20)-STEP(110, 110), 30, BF
      FOR X% = 0 TO UBOUND(Sprite, 1) - 1
        FOR Y% = 0 TO UBOUND(Sprite, 2) - 1
          TegnFelt X%, Y%, Sprite(X%, Y%)
      NEXT Y%, X%
    END IF
    VentPaaMuseSlip
    VisMus

  END IF
ELSE    'hvis venstre museknap er sluppet
  X% = ((Xmus% \ 2) - Billede.VenstreMargin) \ Billede.Feltstr
  Y% = (Ymus% - Billede.TopMargin) \ Billede.Feltstr
  'Musepositionen skrives hvis den er ny
  IF Xmus% \ 2 > Billede.VenstreMargin AND Xmus% \ 2 < Billede.VenstreMargin + Billede.Feltstr * UBOUND(Sprite, 1) AND Ymus% > Billede.TopMargin AND Ymus% < Billede.TopMargin + Billede.Feltstr * UBOUND(Sprite, 2) THEN
    IF X% <> Billede.ForrigeXfelt OR Y% <> Billede.ForrigeYfelt THEN
      SkrivMusePosition X%, Y%
      Billede.ForrigeYfelt = Y%
      Billede.ForrigeXfelt = X%
    END IF
  END IF
  IF Billede.Valgigang = "T" AND CheckFelt(X%, Y%) <> -1 THEN
    Billede.Xop = X%
    Billede.Yop = Y%
    Billede.Valgigang = "F"
    IF Billede.Xned < Billede.Xop - 1 AND Billede.Yned < Billede.Yop - 1 AND AktivtVaerktoej = 3 THEN
      ValgtOmraade = "T"
    ELSE
      ValgtOmraade = "F"
      GemMus
      FOR TempX% = Billede.Xned TO Billede.Xop
        FOR TempY% = Billede.Yned TO Billede.Yop
          TegnFelt TempX%, TempY%, Sprite(TempX%, TempY%)
        NEXT TempY%, TempX%
      VisMus
    END IF
         
    SELECT CASE AktivtVaerktoej
      CASE 4      'Fyldt Kasse
        GemMus
        FOR XFelt% = Billede.Xned TO Billede.Xop
          FOR YFelt% = Billede.Yned TO Billede.Yop
            Sprite(XFelt%, YFelt%) = mus.Farve
            TegnFelt XFelt%, YFelt%, Sprite(XFelt%, YFelt%)
        NEXT YFelt%, XFelt%
        Billede.Beskidt = "T"
        VisMus

      CASE 5      'Ramme
        TegnValgtOmraade X%, Y%
        GemMus
        FOR XFelt% = Billede.Xned TO Billede.Xop
          FOR YFelt% = Billede.Yned TO Billede.Yop
            IF XFelt% = Billede.Xned OR XFelt% = Billede.Xop OR YFelt% = Billede.Yned OR YFelt% = Billede.Yop THEN
              Sprite(XFelt%, YFelt%) = mus.Farve
              TegnFelt XFelt%, YFelt%, Sprite(XFelt%, YFelt%)
            END IF
        NEXT YFelt%, XFelt%
        Billede.Beskidt = "T"
        VisMus
    END SELECT
  ELSE
    IF ValgtOmraade = "T" THEN
      FOR XFelt% = Billede.Xned TO Billede.Xop
        FOR YFelt% = Billede.Yned TO Billede.Yop
          IF XFelt% = Billede.Xned OR XFelt% = Billede.Xop OR YFelt% = Billede.Yned OR YFelt% = Billede.Yop THEN TegnFelt XFelt%, YFelt%, (RND * 5) * 2 + 90
      NEXT YFelt%, XFelt%
    END IF
  END IF


END IF

IF RB% THEN
  IF Xmus% / 2 > Billede.VenstreMargin AND Xmus% / 2 < Billede.VenstreMargin + Billede.Feltstr * UBOUND(Sprite, 1) AND Ymus% > Billede.TopMargin AND Ymus% < Billede.TopMargin + Billede.Feltstr * UBOUND(Sprite, 2) THEN
    X% = ((Xmus% / 2) - Billede.VenstreMargin) \ Billede.Feltstr
    Y% = (Ymus% - Billede.TopMargin) \ Billede.Feltstr
    OpdaterValgtFarve Sprite(X%, Y%)
  'Ellers hvis der peges p PAL knappen
  ELSEIF Xmus% > 585 AND Xmus% < 617 AND Ymus% < 197 AND Ymus% > 179 THEN
      HentPalette ""
  END IF
END IF
END SUB

SUB CheckTast (tast$)

SELECT CASE tast$
 
  CASE CHR$(27)
  IF JaNejTryk("Vil du slutte?") THEN
    SCREEN 0
    WIDTH 80
    COLOR 8
    PRINT "XS-EDIT Version " + Version$ + " - Jakob Krarup, 1998"
    COLOR 7
    END
  END IF

  CASE CHR$(0) + CHR$(60)       'F2 - NY
    MenuPunktValgt 0, 0
 
  CASE CHR$(0) + CHR$(61)       'F3 - ben BSV
    MenuPunktValgt 0, 1
 
  CASE CHR$(0) + CHR$(62)       'F4 - ben BIN
    MenuPunktValgt 0, 2
 
  CASE CHR$(0) + CHR$(63)       'F5 - Gem BSV
    MenuPunktValgt 0, 3
 
  CASE CHR$(0) + CHR$(64)       'F6 - Gem BIN
    MenuPunktValgt 0, 4
 
  CASE CHR$(0) + CHR$(65)       'F7 - Gem MSK
    MenuPunktValgt 0, 5
 
  CASE CHR$(0) + CHR$(66)       'F8 - StandardPalette
    HentPalette ""

  'CASE CHR$(0) + CHR$(67)       'F9 - test farvefinder
  '  Besked "Nrmeste farve", STR$(NaermesteFarve(52, 52, 52)), 1, 5

  CASE CHR$(0) + CHR$(68)       'F10 - Afslut
    MenuPunktValgt 0, 6

  CASE CHR$(10)         'CTRL + ENTER
    VisSomFelter

END SELECT

END SUB

SUB FlytValgtOmraade

DIM X1%, Y1%, X2%, Y2%, XFlyt%, YFlyt%

'Yderkanterne af det valgte omrde lgges i X1, X2, Y1 og Y2
X1% = Billede.Xned + 1
Y1% = Billede.Yned + 1
X2% = Billede.Xop - 1
Y2% = Billede.Yop - 1

'S overtegner vi det gamle valgte omrde
FOR TempX% = Billede.Xned TO Billede.Xop
  FOR TempY% = Billede.Yned TO Billede.Yop
    TegnFelt TempX%, TempY%, Sprite(TempX%, TempY%)
NEXT TempY%, TempX%
 
'S laver vi huskeomrdet stort nok til det valgte omrde
REDIM HuskeOmraade(X2% - X1%, Y2% - Y1%) AS INTEGER
'og lgger den valgte billeddel over i huskeomrdet
FOR FeltX% = X1% TO X2%
  FOR FeltY% = Y1% TO Y2%
    HuskeOmraade(FeltX% - X1%, FeltY% - Y1%) = Sprite(FeltX%, FeltY%)
NEXT FeltY%, FeltX%

'Slutteligt klipper vi et hul i den gamle sprite
FOR FeltX% = X1% TO X2%
  FOR FeltY% = Y1% TO Y2%
    Sprite(FeltX%, FeltY%) = 0
NEXT FeltY%, FeltX%

DO
  tast$ = INKEY$
  SELECT CASE tast$
   
    CASE CHR$(0) + "K"     'Venstre
      FlytX% = -1
      FlytY% = 0
      GOSUB Flyt:
   
    CASE CHR$(0) + "M"     'Hjre
      FlytX% = 1
      FlytY% = 0
      GOSUB Flyt:
   
    CASE CHR$(0) + "H"     'Op
      FlytY% = -1
      FlytX% = 0
      GOSUB Flyt:

    CASE CHR$(0) + "P"     'Ned
      FlytY% = 1
      FlytX% = 0
      GOSUB Flyt:

    CASE CHR$(13)       'Enter - frdig med at flytte
      ValgtOmraade = "F"
      'Vi tegner billedet i dets nye placering
      FOR FeltX% = X1% TO X2%
        FOR FeltY% = Y1% TO Y2%
          Sprite(FeltX%, FeltY%) = HuskeOmraade(FeltX% - X1%, FeltY% - Y1%)
          TegnFelt FeltX%, FeltY%, Sprite(FeltX%, FeltY%)
      NEXT FeltY%, FeltX%
      EXIT SUB
  END SELECT

LOOP

Flyt:

'Frst checkes der om yderkanterne ikke gr uden for billedet
IF X1% + FlytX% >= 0 AND X2% + FlytX% < UBOUND(Sprite, 1) AND Y1% + FlytY% >= 0 AND Y2% + FlytY% < UBOUND(Sprite, 2) THEN
 
  'Vi sletter alt i det felt der skal flyttes
  FOR FeltX% = X1% TO X2%
    FOR FeltY% = Y1% TO Y2%
      TegnFelt FeltX%, FeltY%, Sprite(FeltX%, FeltY%)
  NEXT FeltY%, FeltX%
     
    'Vi tegner billedet i dets nye placering
    FOR FeltX% = X1% TO X2%
      FOR FeltY% = Y1% TO Y2%
        TegnFelt FeltX% + FlytX%, FeltY% + FlytY%, HuskeOmraade(FeltX% - X1%, FeltY% - Y1%)
    NEXT FeltY%, FeltX%
        

'S ndrer vi placeringen af det valgte omrde til hvis vi skal flytte mere
  X1% = X1% + FlytX%
  X2% = X2% + FlytX%
  Y1% = Y1% + FlytY%
  Y2% = Y2% + FlytY%

END IF
RETURN
END SUB

SUB Fyld (X%, Y%)

REDIM Husker(0 TO UBOUND(Sprite, 1) - 1, 0 TO UBOUND(Sprite, 2) - 1) AS INTEGER
'Frst laver vi en matrice med et 1 i alle de felter der mske skal fyldes
FOR Xpixel% = 0 TO UBOUND(Sprite, 1) - 1
  FOR Ypixel% = 0 TO UBOUND(Sprite, 2) - 1
    IF Sprite(Xpixel%, Ypixel%) = Sprite(X%, Y%) THEN Husker(Xpixel%, Ypixel%) = 1
NEXT Ypixel%, Xpixel%

AntalFelterDerSkalFyldes = 1
Husker(X%, Y%) = 2      'Dette felt skal fyldes
GemMus
DO
FOR Xpixel% = 0 TO UBOUND(Sprite, 1) - 1
  FOR Ypixel% = 0 TO UBOUND(Sprite, 2) - 1
    IF Husker(Xpixel%, Ypixel%) = 2 THEN        'S skal det fyldes
    Sprite(Xpixel%, Ypixel%) = mus.Farve
    Husker(Xpixel%, Ypixel%) = 0
    AntalFelterDerSkalFyldes = AntalFelterDerSkalFyldes - 1
    TegnFelt Xpixel%, Ypixel%, mus.Farve
    FOR Xchange% = -1 TO 1
      FOR Ychange% = -1 TO 1
        'Hvis det er et felt over/under eller ved siden af feltet
        IF Xchange% = 0 OR Ychange% = 0 THEN
          'og det er inden for spriten
          IF CheckFelt(Xpixel% + Xchange%, Ypixel% + Ychange%) > -1 THEN
            'og det mske skal fyldes i henhold til husker s:
            IF Husker(Xpixel% + Xchange%, Ypixel% + Ychange%) = 1 THEN
              Husker(Xpixel% + Xchange%, Ypixel% + Ychange%) = 2
              AntalFelterDerSkalFyldes = AntalFelterDerSkalFyldes + 1
            END IF
          END IF
        END IF
    NEXT Ychange%, Xchange%
  END IF
NEXT Ypixel%, Xpixel%
LOOP WHILE AntalFelterDerSkalFyldes >= 1
VisMus
END SUB

SUB GemBIN (FilNavn$)
  
DIM BilledMatrice(UBOUND(Sprite, 1) * UBOUND(Sprite, 2) + 4) AS INTEGER

billedetsNavn$ = FilNavn$ + ".BIN"
Billede.FilNavn = FilNavn$
OPEN billedetsNavn$ FOR BINARY AS #1

  FOR Col = 0 TO 255            'Paletten skrives i filen
    PUT #1, , Farve(Col).R
    PUT #1, , Farve(Col).G
    PUT #1, , Farve(Col).B
  NEXT Col
  Bredde% = UBOUND(Sprite, 1)
  Hoejde% = UBOUND(Sprite, 2)
  PUT #1, , Bredde%              'Strrelsen skrives i filen
  PUT #1, , Hoejde%
  FOR Y = 0 TO UBOUND(Sprite, 2) - 1      'Alle pixels aflses og lgges i filen
    FOR X = 0 TO UBOUND(Sprite, 1) - 1
      pixel = CHR$(Sprite(X, Y))
      PUT #1, , pixel
  NEXT X, Y
CLOSE #1
GET (205, 25)-STEP(UBOUND(Sprite, 1) - 1, UBOUND(Sprite, 2) - 1), BilledMatrice
CLS
PAINT (1, 1), 30
Kasse 50, 30, 220, 140, 30 'siderammen
PUT ((320 - Bredde%) / 2, (200 - Hoejde%) / 2), BilledMatrice, PSET
Skriv billedetsNavn$ + " er gemt", -1, 50, -1, 1, 1, 0
SLEEP
WHILE LEN(INKEY$): WEND
LavSkaerm
Billede.Beskidt = "F"

END SUB

SUB GemBSV (FilNavn$)

DIM BilledMatrice(UBOUND(Sprite, 1) * UBOUND(Sprite, 2) + 4) AS INTEGER

GET (205, 25)-STEP(UBOUND(Sprite, 1) - 1, UBOUND(Sprite, 2) - 1), BilledMatrice
DEF SEG = VARSEG(BilledMatrice(0))
billedetsNavn$ = FilNavn$ + ".BSV"
BSAVE billedetsNavn$, VARPTR(BilledMatrice(0)), UBOUND(Sprite, 1) * UBOUND(Sprite, 2) + 4

'Paletten gemmes
 
Udpalette$ = FilNavn$ + ".PAL"
OPEN Udpalette$ FOR BINARY AS #1
  FOR Col = 0 TO 255            'Paletten skrives i filen
    PUT #1, , Farve(Col).R
    PUT #1, , Farve(Col).G
    PUT #1, , Farve(Col).B
  NEXT Col
CLOSE #1
 
   CLS
   BLOAD billedetsNavn$, VARPTR(BilledMatrice(0))
   PAINT (1, 1), 30
   Kasse 50, 30, 220, 140, 30 'siderammen
   PUT ((320 - UBOUND(Sprite, 1)) / 2, (200 - UBOUND(Sprite, 2)) / 2), BilledMatrice, PSET
   Skriv billedetsNavn$ + " er gemt", -1, 40, -1, 1, 1, 0
   Skriv Udpalette$ + " er gemt", -1, 155, -1, 1, 1, 0
   SLEEP
   LavSkaerm

Billede.Beskidt = "F"
END SUB

SUB GemMaske (FilNavn$)

billedetsNavn$ = FilNavn$ + ".MSK"

DIM BilledMatrice(UBOUND(Sprite, 1), UBOUND(Sprite, 2)) AS INTEGER

OPEN billedetsNavn$ FOR BINARY AS #1

  FOR Col = 0 TO 255            'Paletten skrives i filen
    PUT #1, , Farve(Col).R
    PUT #1, , Farve(Col).G
    PUT #1, , Farve(Col).B
  NEXT Col
  Bredde% = UBOUND(Sprite, 1)
  Hoejde% = UBOUND(Sprite, 2)
  PUT #1, , Bredde%              'Strrelsen skrives i filen
  PUT #1, , Hoejde%
  FOR Y = 0 TO UBOUND(Sprite, 2) - 1      'Alle pixels aflses og lgges i filen
    FOR X = 0 TO UBOUND(Sprite, 1) - 1
      IF Sprite(X, Y) THEN
        pixel = CHR$(0)
      ELSE
        pixel = CHR$(255)
      END IF
      PUT #1, , pixel
      BilledMatrice(X, Y) = ASC(pixel)
  NEXT X, Y
CLOSE #1

CLS
PAINT (1, 1), 30
Kasse 50, 30, 220, 140, 30 'siderammen
Xoffset% = 160 - UBOUND(Sprite, 1) / 2
Yoffset% = 110 - UBOUND(Sprite, 2) / 2
FOR X% = 0 TO UBOUND(Sprite, 1) - 1
  FOR Y% = 0 TO UBOUND(Sprite, 2) - 1
      PSET (Xoffset% + X%, Yoffset% + Y%), BilledMatrice(X%, Y%)
  NEXT Y%, X%
Skriv "Masken til " + billedetsNavn$ + " er gemt", -1, 50, -1, 1, 1, 0
SLEEP
WHILE LEN(INKEY$): WEND
LavSkaerm



END SUB

DEFLNG A-Z
SUB GemMus
 ax% = 2
 MouseDriver ax%, 0, 0, 0
END SUB

DEFSNG A-Z
SUB HentBin

billedetsNavn$ = HentFilnavne$("BIN")
IF LEN(billedetsNavn$) = 0 THEN EXIT SUB
OPEN billedetsNavn$ FOR BINARY AS #1

  FOR Col = 0 TO 255            'Paletten hentes
    OUT &H3C8, Col
    GET #1, , Farve(Col).R
    OUT &H3C9, ASC(Farve(Col).R)
    GET #1, , Farve(Col).G
    OUT &H3C9, ASC(Farve(Col).G)
    GET #1, , Farve(Col).B
    OUT &H3C9, ASC(Farve(Col).B)
  NEXT Col
  GET #1, , Bredde%              'Strrelsen hentes
  GET #1, , Hoejde%
  IF Bredde% > 100 OR Hoejde% > 100 THEN
    Besked "Billedet er for stort", "", 33, 2
    CLOSE #1
    EXIT SUB
  END IF
  REDIM Sprite(Bredde%, Hoejde%) AS INTEGER
  FOR Y% = 0 TO UBOUND(Sprite, 2) - 1      'Alle pixels aflses og lgges i filen
    FOR X% = 0 TO UBOUND(Sprite, 1) - 1
      GET #1, , pixel
      Sprite(X%, Y%) = ASC(pixel)
  NEXT X%, Y%
CLOSE #1
LavSkaerm
Billede.Beskidt = "F"

END SUB

SUB HentBSV

billedetsNavn$ = HentBSVFilnavne$("BSV")
IF LEN(billedetsNavn$) = 0 THEN EXIT SUB

'Frst checker vi strrelsen p billedet:
OPEN billedetsNavn$ FOR BINARY AS #1
  GET #1, 8, pixel
  GET #1, 9, pixel2
         
  IF ASC(pixel2) > 0 THEN
    PicWidth& = (ASC(pixel) + ASC(pixel2) * 256) / 8
  ELSE
    PicWidth& = ASC(pixel) / 8
  END IF
         
GET #1, 10, pixel
GET #1, 11, pixel2
IF ASC(pixel2) > 0 THEN
  PicHeight& = ASC(pixel) + ASC(pixel2) * 256
ELSE
  PicHeight& = ASC(pixel)
END IF
CLOSE #1
IF PicHeight& <= 0 OR PicHeight& > 100 OR PicWidth& <= 0 OR PicWidth& > 100 THEN
  Besked "Billedet er for stort!", "", 4, 3
  CLOSE #1
  EXIT SUB
ELSE
  OPEN billedetsNavn$ FOR BINARY AS #1
    IF LOF(1) <> PicWidth& * PicHeight& + 11 THEN
      Besked "Filen er ikke en gyldig BSV fil", "Bytes" + STR$(LOF(1)) + " " + STR$(Bredde%) + " " + STR$(Hoejde%), 4, 3
      CLOSE #1
      EXIT SUB
    END IF
  CLOSE #1
  REDIM Sprite(PicWidth&, PicHeight&) AS INTEGER
  LavSkaerm
END IF

DEF SEG = VARSEG(knap%(0))
BLOAD billedetsNavn$, VARPTR(knap%(0))
GemMus
PUT (205, 25), knap%(0), PSET
FOR X% = 0 TO UBOUND(Sprite, 1) - 1
  FOR Y% = 0 TO UBOUND(Sprite, 2) - 1
  Sprite(X%, Y%) = POINT(205 + X%, 25 + Y%)
  TegnFelt X%, Y%, Sprite(X%, Y%)
NEXT Y%, X%
VisMus
Billede.Beskidt = "F"
END SUB

FUNCTION HentBSVFilnavne$ (Efternavn$)

DIM Getter(30000) AS INTEGER
DIM PicHeight&, PicWidth&, GyldigFil$
DialogBoxWidth% = 200
DialogBoxHeight% = 125

XDialogBox% = (320 - DialogBoxWidth%) / 2
YDialogBox% = (200 - DialogBoxHeight%) / 2

AntalFilerVist% = 5

GemMus

GET (XDialogBox%, YDialogBox%)-STEP(DialogBoxWidth% - 1, DialogBoxHeight% - 1), Getter

BSVEfterslet:   'FYYYYYYYYYYYY - GOTO!!!
'DIR switches:  /b  : bare format, lists filenames only, no date etc.
'               /on : sorted by name
'               /a-d: doesn't list directories
'               /l  : lower case
'               > sprites.tmp  : directs output to file "sprites.tmp"

SHELL "DIR /b /on /a-d /l *." + Efternavn$ + " > Sprites.tmp"

AntalFilerHentet% = 0
OPEN "Sprites.tmp" FOR INPUT AS #1
  WHILE NOT EOF(1) AND AntalFilerHentet% < 299
    INPUT #1, FilNavn(AntalFilerHentet%)
    AntalFilerHentet% = AntalFilerHentet% + 1
  WEND
  AntalFilerHentet% = AntalFilerHentet% - 1   'For at undg den tomme linie
CLOSE #1
KILL "Sprites.tmp"
IF AntalFilerHentet% < 0 THEN
  Besked "Der er ingen '" + Efternavn$ + "' filer her i biblioteket", "", 33, 2
  VisMus
  EXIT FUNCTION
ELSE
  IF AntalFilerHentet% > 98 THEN Besked "For mange BSV filer i biblioteket!", "Jeg kan maximum sortere 100", -1, 32
'Besked STR$(AntalFilerHentet% + 1) + " '" + efternavn$ + "'" + " filer fundet", "", -1, 2

  'selve kassen
  'LINE (XDialogBox% - 1, YDialogBox% - 1)-STEP(DialogBoxWidth% + 1, DialogBoxHeight% + 1), 27, BF
  LINE (XDialogBox%, YDialogBox%)-STEP(DialogBoxWidth% - 1, DialogBoxHeight% - 1), 30, BF
  LINE (XDialogBox%, YDialogBox%)-STEP(DialogBoxWidth% - 1, DialogBoxHeight% - 1), 0, B
  LINE (XDialogBox%, YDialogBox%)-STEP(DialogBoxWidth% - 1, 11), 28, BF
  LINE (XDialogBox%, YDialogBox%)-STEP(DialogBoxWidth% - 1, 11), 0, B

  Skriv "Hvilken " + Efternavn$ + "-fil?", -1, YDialogBox% + 3, -1, 1, 1, 0
  LINE (XDialogBox% + 5, YDialogBox% + 15)-STEP(80, 56), 0, BF
  LINE (XDialogBox% + 5, YDialogBox% + 15)-STEP(80, 56), 28, B

  'Hjde x bredde felt
  LINE (XDialogBox% + 50, YDialogBox% + 75)-STEP(35, 11), 0, BF
  LINE (XDialogBox% + 50, YDialogBox% + 75)-STEP(35, 11), 28, B
  Skriv "Hjde:", XDialogBox% + 5, YDialogBox% + 77, 28, 1, 1, 0

  LINE (XDialogBox% + 50, YDialogBox% + 85)-STEP(35, 11), 0, BF
  LINE (XDialogBox% + 50, YDialogBox% + 85)-STEP(35, 11), 28, B
  Skriv "Bredde:", XDialogBox% + 5, YDialogBox% + 87, 28, 1, 1, 0

  'Ugyldigt format felt

  LINE (XDialogBox% + 5, YDialogBox% + 105)-STEP(80, 11), 0, BF
  LINE (XDialogBox% + 5, YDialogBox% + 105)-STEP(80, 11), 28, B

  'vise felt
  LINE (150, YDialogBox% + 15)-STEP(101, 101), 0, BF
  LINE (150, YDialogBox% + 15)-STEP(101, 101), 28, B
  GOSUB BSVVisFilNavne
  DO
    tast$ = UCASE$(INKEY$)
    IF LEN(tast$) THEN
      SELECT CASE tast$
        CASE CHR$(0) + CHR$(81)        'Page down
        ValgtFil% = ValgtFil% + 5

        CASE CHR$(0) + CHR$(73)        'Page up
          ValgtFil% = ValgtFil% - 5

        CASE CHR$(0) + CHR$(83)        'Delete
          IF JaNejTryk("Vil du slette filen: '" + RTRIM$(FilNavn(ValgtFil%)) + "' ?") THEN
            Besked "Nu sletter jeg: '" + RTRIM$(FilNavn(ValgtFil%)) + "'", "", 32, 2
            SHELL "attrib " + RTRIM$(FilNavn(ValgtFil%)) + " -r "
            SHELL "del " + RTRIM$(FilNavn(ValgtFil%))
            ValgtFil% = 0
            OeversteFil% = 0
            GOTO BSVEfterslet
          END IF
     
        CASE CHR$(0) + CHR$(79)        'end
          ValgtFil% = AntalFilerHentet%
     
        CASE CHR$(0) + CHR$(71)        'home
          ValgtFil% = 0
     
        CASE CHR$(0) + "H"
          ValgtFil% = ValgtFil% - 1
      
        CASE CHR$(0) + "P"
          ValgtFil% = ValgtFil% + 1
    
        CASE CHR$(27)     'esc
          PUT (XDialogBox%, YDialogBox%), Getter, PSET
          VisMus
          HentBSVFilnavne$ = ""
          EXIT FUNCTION

        CASE CHR$(13)     'ENTER
          IF GyldigFil$ = "TRUE" THEN
            PUT (XDialogBox%, YDialogBox%), Getter, PSET
            VisMus
            HentBSVFilnavne$ = FilNavn(ValgtFil%)
            Billede.FilNavn = MID$(FilNavn(ValgtFil%), 1, LEN(RTRIM$(LTRIM$(FilNavn(ValgtFil%)))) - 4)
            EXIT FUNCTION
          ELSE
            SOUND 250, 1
          END IF
       
        CASE CHR$(10)   'CTRL + ENTER (viser som fliser)
          IF GyldigFil$ = "TRUE" THEN
            AntaliHoejden% = INT(100 / PicHeight&)
            AntaliBredden% = INT(100 / PicWidth&)
            SamletBredde% = PicWidth& * AntaliBredden%
            SamletHoejde% = PicHeight& * AntaliHoejden%

            DEF SEG = VARSEG(knap%(0))
            BLOAD FilNavn(ValgtFil%), VARPTR(knap%(0))
         
            FOR Xcount% = 0 TO AntaliBredden% - 1
              FOR Ycount% = 0 TO AntaliHoejden% - 1
                PUT (201 - (SamletBredde% / 2) + PicWidth& * Xcount%, (YDialogBox% + 66) - (SamletHoejde% / 2) + PicHeight& * Ycount%), knap%(0), PSET
              NEXT Ycount%, Xcount%
              SLEEP
           END IF
        CASE ELSE
          FOR BogstavCheck% = 0 TO AntalFilerHentet%
            IF UCASE$(LEFT$(FilNavn(BogstavCheck%), 1)) = UCASE$(tast$) THEN ValgtFil% = BogstavCheck%: EXIT FOR
          NEXT BogstavCheck%

      END SELECT
 
     'Her checker vi om vi skulle vre get over grnsen
 
      IF ValgtFil% < 0 THEN ValgtFil% = 0
      IF ValgtFil% < OeversteFil% THEN OeversteFil% = ValgtFil%
      IF ValgtFil% > AntalFilerHentet% THEN ValgtFil% = AntalFilerHentet%
      IF ValgtFil% > OeversteFil% + AntalFilerVist% - 1 THEN OeversteFil% = ValgtFil% - (AntalFilerVist% - 1)
      GOSUB BSVVisFilNavne
    END IF
  LOOP



END IF


BSVVisFilNavne:


FOR Fil = OeversteFil% TO OeversteFil% + AntalFilerVist% - 1

  billedetsNavn$ = MID$(FilNavn(Fil), 1, LEN(RTRIM$(FilNavn(Fil))) - 4)
  'Overskriver filnavnet der stod her fr
  'LINE (XDialogBox% + 5, YDialogBox% + 15)-STEP(80, 56), 0, BF
  LINE (XDialogBox% + 6, 11 * (Fil - OeversteFil%) + YDialogBox% + 16)-STEP(78, 10), 30, BF
  IF Fil = ValgtFil% THEN
    LINE (XDialogBox% + 6, 11 * (Fil - OeversteFil%) + YDialogBox% + 16)-STEP(78, 10), 108, BF
    LINE (XDialogBox% + 6, 11 * (Fil - OeversteFil%) + YDialogBox% + 16)-STEP(78, 10), 100, B
    Skriv billedetsNavn$, XDialogBox% + 8, 11 * (ValgtFil% - OeversteFil%) + YDialogBox% + 17, 255, 1, 1, 0
  ELSE
    Skriv billedetsNavn$, XDialogBox% + 8, 11 * (Fil - OeversteFil%) + YDialogBox% + 17, 25, 1, 1, 0
  END IF

NEXT Fil

IF UCASE$(Efternavn$) = "BSV" THEN GOSUB VisBSVFilsub
RETURN

VisBSVFilsub:
        
'Frst checker vi strrelsen p billedet:
OPEN FilNavn(ValgtFil%) FOR BINARY AS #1
  GET #1, 8, pixel
  GET #1, 9, pixel2
          
  IF ASC(pixel2) > 0 THEN
    PicWidth& = (ASC(pixel) + ASC(pixel2) * 256) / 8
  ELSE
    PicWidth& = ASC(pixel) / 8
  END IF
          
GET #1, 10, pixel
GET #1, 11, pixel2
IF ASC(pixel2) > 0 THEN
  PicHeight& = ASC(pixel) + ASC(pixel2) * 256
ELSE
  PicHeight& = ASC(pixel)
END IF

'Sletter det tegnede billede og strrelsesboksene
LINE (150, YDialogBox% + 15)-STEP(101, 101), 0, BF
LINE (150, YDialogBox% + 15)-STEP(101, 101), 28, B
LINE (XDialogBox% + 50, YDialogBox% + 75)-STEP(35, 11), 0, BF
LINE (XDialogBox% + 50, YDialogBox% + 75)-STEP(35, 11), 28, B
LINE (XDialogBox% + 50, YDialogBox% + 85)-STEP(35, 11), 0, BF
LINE (XDialogBox% + 50, YDialogBox% + 85)-STEP(35, 11), 28, B
LINE (XDialogBox% + 5, YDialogBox% + 105)-STEP(80, 11), 0, BF
LINE (XDialogBox% + 5, YDialogBox% + 105)-STEP(80, 11), 28, B

IF PicHeight& <= 100 AND PicWidth& <= 100 AND PicHeight& > 0 AND PicWidth& > 0 AND LOF(1) <= PicWidth& * PicHeight& + 15 THEN
  CLOSE #1
  DEF SEG = VARSEG(knap%(0))
  BLOAD FilNavn(ValgtFil%), VARPTR(knap%(0))
  PUT (201 - (PicWidth& / 2), (YDialogBox% + 66) - (PicHeight& / 2)), knap%(0), PSET
  'Skriver strrelserne
  Skriv STR$(PicHeight&), XDialogBox% + 52, YDialogBox% + 77, 26, 1, 1, 0
  Skriv STR$(PicWidth&), XDialogBox% + 52, YDialogBox% + 87, 26, 1, 1, 0
  GyldigFil$ = "TRUE"
ELSE
  IF LOF(1) <> PicWidth& * PicHeight& + 11 THEN
    Skriv "Ugyldig fil!", XDialogBox% + 10, YDialogBox% + 107, 34, 1, 1, 0
  ELSE
    Skriv "For stort!", XDialogBox% + 10, YDialogBox% + 107, 34, 1, 1, 0
  END IF
  GyldigFil$ = "FALSE"
END IF
CLOSE #1

RETURN

END FUNCTION

FUNCTION HentFilnavne$ (Efternavn$)

DIM Getter(9000) AS INTEGER

AntalFilerVist% = 5

GemMus

GET (100, 70)-STEP(119, 74), Getter

'DIR switches:  /b  : bare format, lists filenames only, no date etc.
'               /on : sorted by name
'               /a-d: doesn't list directories
'               /l  : lower case
'               > sprites.tmp  : directs output to file "sprites.tmp"

SHELL "DIR /b /on /a-d /l *." + Efternavn$ + " > Sprites.tmp"
AntalFilerHentet% = 0
OPEN "Sprites.tmp" FOR INPUT AS #1
  WHILE NOT EOF(1) AND AntalFilerHentet% < 299
    INPUT #1, FilNavn(AntalFilerHentet%)
    AntalFilerHentet% = AntalFilerHentet% + 1
  WEND
  AntalFilerHentet% = AntalFilerHentet% - 1   'For at undg den tomme linie
CLOSE #1
KILL "Sprites.tmp"
IF AntalFilerHentet% < 0 THEN
  Besked "Der er ingen '" + Efternavn$ + "' filer her i biblioteket", "", 33, 2
  VisMus
  EXIT FUNCTION
ELSE
'  Besked STR$(AntalFilerHentet% + 1) + " '" + Efternavn$ + "'" + " filer fundet", "", -1, 2

  LINE (100, 70)-STEP(119, 74), 30, BF
  LINE (100, 70)-STEP(119, 74), 0, B
  Skriv "Hvilken " + Efternavn$ + "-fil?", -1, 75, -1, 1, 1, 0
  LINE (120, 85)-STEP(80, 56), 0, BF
  LINE (120, 85)-STEP(80, 56), 28, B
  GOSUB VisFilNavne
  DO
    tast$ = UCASE$(INKEY$)
    IF LEN(tast$) THEN
      SELECT CASE tast$
        CASE CHR$(0) + CHR$(81)        'Page down
        ValgtFil% = ValgtFil% + 5

        CASE CHR$(0) + CHR$(73)        'Page up
          ValgtFil% = ValgtFil% - 5
     
        CASE CHR$(0) + CHR$(79)        'end
          ValgtFil% = AntalFilerHentet%
     
        CASE CHR$(0) + CHR$(71)        'home
          ValgtFil% = 0
     
        CASE CHR$(0) + "H"
          ValgtFil% = ValgtFil% - 1
     
        CASE CHR$(0) + "P"
          ValgtFil% = ValgtFil% + 1
    
        CASE CHR$(27)     'esc
          PUT (100, 70), Getter, PSET
          VisMus
          HentFilnavne$ = ""
          EXIT FUNCTION
      
        CASE CHR$(13)     'enter
          PUT (100, 70), Getter, PSET
          VisMus
          HentFilnavne$ = FilNavn(ValgtFil%)
          Billede.FilNavn = MID$(FilNavn(ValgtFil%), 1, LEN(RTRIM$(LTRIM$(FilNavn(ValgtFil%)))) - 4)
          EXIT FUNCTION
        CASE ELSE
          FOR BogstavCheck% = 0 TO AntalFilerHentet%
            IF UCASE$(LEFT$(FilNavn(BogstavCheck%), 1)) = UCASE$(tast$) THEN ValgtFil% = BogstavCheck%: EXIT FOR
          NEXT BogstavCheck%

      END SELECT
 
     'Her checker vi om vi skulle vre get over grnsen
 
      IF ValgtFil% < 0 THEN ValgtFil% = 0
      IF ValgtFil% < OeversteFil% THEN OeversteFil% = ValgtFil%
      IF ValgtFil% > AntalFilerHentet% THEN ValgtFil% = AntalFilerHentet%
      IF ValgtFil% > OeversteFil% + AntalFilerVist% - 1 THEN OeversteFil% = ValgtFil% - (AntalFilerVist% - 1)
      GOSUB VisFilNavne
    END IF
  LOOP



END IF


VisFilNavne:


FOR Fil = OeversteFil% TO OeversteFil% + AntalFilerVist% - 1

  billedetsNavn$ = MID$(FilNavn(Fil), 1, LEN(RTRIM$(FilNavn(Fil))) - 4)
  'Overskriver filnavnet der stod her fr
  LINE (121, 11 * (Fil - OeversteFil%) + 86)-STEP(78, 10), 30, BF
  IF Fil = ValgtFil% THEN
    LINE (121, 11 * (Fil - OeversteFil%) + 86)-STEP(78, 10), 108, BF
    LINE (121, 11 * (Fil - OeversteFil%) + 86)-STEP(78, 10), 100, B
    Skriv billedetsNavn$, -1, 11 * (ValgtFil% - OeversteFil%) + 87, 255, 1, 1, 0
  ELSE
    Skriv billedetsNavn$, -1, 11 * (Fil - OeversteFil%) + 87, 25, 1, 1, 0
  END IF

NEXT Fil

RETURN

END FUNCTION

SUB HentFont

RESTORE Font
FOR X = 0 TO 839
  READ a
  Alfabet(X) = CHR$(a)
NEXT X

END SUB

SUB HentMuseStatus (LB%, RB%, xMouse%, yMouse%)
  ax% = 3
  MouseDriver ax%, bx%, cx%, dx%
  LB% = ((bx% AND 1) <> 0)
  RB% = ((bx% AND 2) <> 0)
  Xmus% = cx%
  Ymus% = dx%
END SUB

SUB HentPalette (PalettensNavn$)

'Her medsendes palettens navn hvis der skal bnes og anvendes en anden
'palette end standardpaletten
'Ellers medsendes ""

IF LEN(PalettensNavn$) THEN
  OPEN PalettensNavn$ FOR BINARY AS #1
    FOR Col = 0 TO 255            'Paletten hentes
      OUT &H3C8, Col
      GET #1, , Farve(Col).R
      OUT &H3C9, ASC(Farve(Col).R)
      GET #1, , Farve(Col).G
      OUT &H3C9, ASC(Farve(Col).G)
      GET #1, , Farve(Col).B
      OUT &H3C9, ASC(Farve(Col).B)
    NEXT Col
  CLOSE #1
ELSE    'hvis standard paletten skal bruges
  RESTORE PALETTELabel

  FOR Col = 0 TO 255 'S sttes der farve p!
    OUT &H3C8, Col
    READ R
    Farve(Col).R = CHR$(R)
    OUT &H3C9, R
   
    READ G
    Farve(Col).G = CHR$(G)
    OUT &H3C9, G

    READ B
    Farve(Col).B = CHR$(B)
    OUT &H3C9, B
  NEXT Col
END IF

END SUB

FUNCTION Indtast$ (Spoergsmaal$, TekstEllerTal$, Forslag$)

DIM Getter((LEN(Spoergsmaal$) * 6 + 20) * 50) AS INTEGER

'TekstEllerTal$ er "TAL" hvis der kun kan indtastes tal

Xmin% = (320 - (LEN(Spoergsmaal$) * 6 + 20)) / 2
Xmax% = Xmin% + (LEN(Spoergsmaal$) * 6 + 20)
Ymin% = 50
Ymax% = 100


GET (Xmin%, Ymin%)-(Xmax%, Ymax%), Getter
LINE (Xmin%, Ymin%)-(Xmax%, Ymax%), 30, BF
LINE (Xmin%, Ymin%)-(Xmax%, Ymax%), 0, B
Skriv Spoergsmaal$, -1, 60, 33, 1, 1, 0
Tekst$ = Forslag$
GOSUB SkrivTekst
DO
  tast$ = INKEY$
  IF LEN(tast$) = 1 THEN
    IF tast$ = CHR$(8) THEN 'Backspace
      IF LEN(Tekst$) > 1 THEN
        Tekst$ = MID$(Tekst$, 1, LEN(Tekst$) - 1)
        tast$ = ""
      ELSE
        Tekst$ = ""
        tast$ = ""
      END IF
      GOSUB SkrivTekst
    ELSEIF ASC(tast$) > 31 AND ASC(tast$) < 173 AND LEN(Tekst$) < 8 THEN
      Tekst$ = Tekst$ + tast$
      tast$ = ""
      GOSUB SkrivTekst
    ELSEIF tast$ = CHR$(27) THEN
      PUT (Xmin%, Ymin%), Getter, PSET
      EXIT FUNCTION
    END IF

  END IF
LOOP WHILE tast$ <> CHR$(13) OR LEN(Navn$) > 8

Indtast$ = Tekst$
PUT (Xmin%, Ymin%), Getter, PSET
EXIT FUNCTION

SkrivTekst:
LinieLaengde = LEN(Tekst$) * 6 + 10
LINE ((320 - LinieLaengde) / 2, 80)-STEP(LinieLaengde, 10), 30, BF
Skriv Tekst$, -1, 80, -1, 1, 1, 0
RETURN

END FUNCTION

SUB InitMus

RESTORE Musedata
FOR I% = 1 TO 57:  READ a$:  H$ = CHR$(VAL("&H" + a$))

MID$(Mouse$, I%, 1) = H$: NEXT I%

ms% = MouseInit%
IF NOT ms% THEN
  PRINT "Du har ikke en musedriver installeret!"
  PRINT "Programmet sluttes derfor."
  END
END IF

END SUB

SUB InitVar

Version$ = "0.99"

Mouse$ = SPACE$(57)

REDIM Sprite%(20, 20)

AktivtVaerktoej = 0

DEF SEG = VARSEG(Knapper%(0))
BLOAD "array.bar", VARPTR(Knapper%(0))

Billede.Beskidt = "F"
Billede.Valgigang = "F"
Billede.FilNavn = "Navnls"
Billede.Fliser = "F"

Menu(0, 0) = "Filer"
Menu(0, 1) = " Ny"
Menu(0, 2) = " bn BSV"
Menu(0, 3) = " bn BIN"
Menu(0, 4) = " Gem BSV"
Menu(0, 5) = " Gem BIN"
Menu(0, 6) = " Gem maske"
Menu(0, 7) = " Afslut"

Menu(1, 0) = "Rediger"
Menu(1, 1) = " Klip til"
Menu(1, 2) = " Spejlvend"
Menu(1, 3) = " Flyt"
Menu(1, 4) = " Bldgr"

Menu(2, 0) = "Strrelse"
Menu(2, 1) = " 10 x 10"
Menu(2, 2) = " 20 x 20"
Menu(2, 3) = " 50 x 50"
Menu(2, 4) = " 75 x 75"
Menu(2, 5) = " 100 x 100"
Menu(2, 6) = " Selvvalgt"

ValgtOmraade = "F"      'Der er ikke valgt et omrde fra starten af

Tabel(0) = 1    'Denne tabel holder 2 i index'ende til at skrive fonten med
Tabel(1) = 2
Tabel(2) = 4
Tabel(3) = 8
Tabel(4) = 16
Tabel(5) = 32
Tabel(6) = 64
Tabel(7) = 128

END SUB

FUNCTION JaNejTryk (Spoergsmaal$)

DIM Getter((LEN(Spoergsmaal$) * 6 + 20) * 50) AS INTEGER

Xmin% = (320 - (LEN(Spoergsmaal$) * 6 + 20)) / 2
Xmax% = Xmin% + (LEN(Spoergsmaal$) * 6 + 20)
Ymin% = 50
Ymax% = 100

GemMus
GET (Xmin%, Ymin%)-(Xmax%, Ymax%), Getter
LINE (Xmin%, Ymin%)-(Xmax%, Ymax%), 30, BF
LINE (Xmin%, Ymin%)-(Xmax%, Ymax%), 26, B
LINE (Xmin% + 1, Ymin% + 1)-(Xmax% - 1, Ymax% - 1), 24, B
LINE (Xmin% + 2, Ymin% + 2)-(Xmax% - 2, Ymax% - 2), 26, B
Skriv Spoergsmaal$, -1, 60, 33, 1, 1, 0
PUT (130, 75), Knapper%(6 * 404), PSET
Skriv "Ja", 134, 81, 22, 1, 1, 0
PUT (170, 75), Knapper%(6 * 404), PSET
Skriv "Nej", 172, 81, 22, 1, 1, 0

MousePut 320, 75
VisMus
MouseRange Xmin% * 2, Ymin%, Xmax% * 2, Ymax%

DO
  tast$ = UCASE$(INKEY$)
  IF tast$ <> "" THEN
    IF tast$ = "J" THEN
      JaNejTryk = 1
      GemMus
      PUT (Xmin%, Ymin%), Getter, PSET
      VisMus
      MouseRange 0, 0, 638, 198
      EXIT FUNCTION
    ELSEIF tast$ = "N" THEN
      JaNejTryk = 0
      GemMus
      PUT (Xmin%, Ymin%), Getter, PSET
      VisMus
      MouseRange 0, 0, 638, 198
      EXIT FUNCTION
    END IF
  END IF
  HentMuseStatus LB%, RB%, X%, Y%
  IF LB% = -1 THEN
    IF Xmus% > 260 AND Xmus% < 298 AND Ymus% > 75 AND Ymus% < 95 THEN
      GemMus
      PUT (130, 75), Knapper%(6 * 404 + 202), PSET
      Skriv "Ja", 134, 81, 22, 1, 1, 0
      VisMus
      tid! = TIMER
      DO
      LOOP WHILE TIMER - tid! < .25
      JaNejTryk = 1
      GemMus
      PUT (Xmin%, Ymin%), Getter, PSET
      VisMus
      MouseRange 0, 0, 638, 198
      EXIT FUNCTION
    ELSEIF Xmus% > 340 AND Xmus% < 378 AND Ymus% > 75 AND Ymus% < 95 THEN
      GemMus
      PUT (170, 75), Knapper%(6 * 404 + 202), PSET
      Skriv "Nej", 172, 81, 22, 1, 1, 0
      VisMus
      tid! = TIMER
      DO
      LOOP WHILE TIMER - tid! < .25
      JaNejTryk = 0
      GemMus
      PUT (Xmin%, Ymin%), Getter, PSET
      VisMus
      MouseRange 0, 0, 638, 198
      EXIT FUNCTION

    END IF
  END IF
LOOP

END FUNCTION

SUB Kasse (XStart%, YStart%, Laengde%, Hoejde%, Farve%)

LINE (XStart%, YStart%)-STEP(Laengde%, Hoejde%), Farve%, B

'Skygge venstre og top
LINE (XStart% - 1, YStart% - 1)-STEP(Laengde% + 2, 0), Farve% + 1, B
LINE (XStart% - 1, YStart% - 1)-STEP(0, Hoejde% + 2), Farve% + 1, B

'Skygge hjre og bund
LINE (XStart% - 1 + Laengde%, YStart% + 1)-STEP(0, Hoejde% - 2), Farve% + 1, B
LINE (XStart% - 1 + Laengde%, YStart% + Hoejde% - 1)-STEP(-Laengde% + 2, 0), Farve% + 1, B

'Highlight venstre og top
LINE (XStart% + 1, YStart% + 1)-STEP(Laengde% - 2, 0), Farve% - 1, B
LINE (XStart% + 1, YStart% + 1)-STEP(0, Hoejde% - 3), Farve% - 1, B

'Highlight Hjre og bund
LINE (XStart% + 1 + Laengde%, YStart%)-STEP(0, Hoejde%), Farve% - 1, B
LINE (XStart% - 1, YStart% + Hoejde% + 1)-STEP(Laengde% + 2, 0), Farve% - 1, B


END SUB

SUB KnapTryk (KnapTrykket AS INTEGER)
IF KnapTrykket <> AktivtVaerktoej THEN
 
  GemMus
  PUT (175, 20 + AktivtVaerktoej * 20), Knapper%(404 * AktivtVaerktoej), PSET
  AktivtVaerktoej = KnapTrykket
  PUT (175, 20 + AktivtVaerktoej * 20), Knapper%(404 * AktivtVaerktoej + 202), PSET
  VisMus
END IF

END SUB

SUB KopierHuskTilSprite


END SUB

SUB LavSkaerm

DIM HuskFliser$      'til at sl fliser fra midlertidigt v. skrmopdatering

HuskFliser$ = "F"
GemMus
CLS
PAINT (1, 1), 30

Kasse 5, 15, 310, 190, 30        'Rammen
Kasse 10, 20, 160, 155, 30      'Tegnefelt

IF UBOUND(Sprite, 1) > UBOUND(Sprite, 2) THEN
  Billede.Feltstr = FIX(150 / UBOUND(Sprite, 1))
ELSE
  Billede.Feltstr = FIX(150 / UBOUND(Sprite, 2))
END IF
IF Billede.Feltstr > 5 THEN Billede.Feltstr = 5

'       Srger for at indstille margenerne for tegnefeltet

Billede.VenstreMargin = 90 - (Billede.Feltstr * UBOUND(Sprite, 1)) / 2
Billede.TopMargin = 98 - Billede.Feltstr * UBOUND(Sprite, 2) / 2

IF Billede.Fliser = "T" THEN
  HuskFliser$ = "T"
  Billede.Fliser = "F"
END IF

FOR X% = 0 TO UBOUND(Sprite, 1) - 1
  FOR Y% = 0 TO UBOUND(Sprite, 2) - 1
  TegnFelt X%, Y%, Sprite(X%, Y%)
NEXT Y%, X%

IF HuskFliser$ = "T" THEN
  Billede.Fliser = "T"
  TegnFelt 0, 0, Sprite%(0, 0)
END IF

Kasse 200, 20, 110, 110, 30     'Visefelt

FOR Y = 0 TO 5
  IF Y = AktivtVaerktoej THEN
    PUT (175, 20 + 20 * Y), Knapper%(404 * Y + 202), PSET
  ELSE
    PUT (175, 20 + 20 * Y), Knapper%(404 * Y), PSET
  END IF

NEXT Y

FOR Taeller = 0 TO 255          'Palette
  LINE ((Taeller MOD 64) * 4 + 32, (Taeller \ 64) * 4 + 180)-STEP(3, 3), Taeller, BF
NEXT Taeller

'Knappen til at loade en ny palette med
'    DEF SEG = VARSEG(knap%(0))
'    BLOAD "pal_knap.bsv", VARPTR(knap%(0))
    'PUT (293, 180), knap, PSET
     PUT (293, 180), Knapper%(202 * 16), PSET
   
    'Tile - knappen
    IF Billede.Fliser = "F" THEN
      PUT (200, 155), Knapper%(404 * 7), PSET
    ELSE
      PUT (200, 155), Knapper%(404 * 7 + 202), PSET
    END IF
'***************************
' Denne rutine srger for at opdatere den valgte farve i paletten
'***************************

FarveHusker% = mus.Farve
TempFarve% = (FarveHusker% + 5) MOD 255
OpdaterValgtFarve TempFarve%
OpdaterValgtFarve FarveHusker%
OpdaterValgtFarve mus.Farve

'Menubjaelken
LINE (0, 0)-STEP(319, 11), 29, BF
Skriv "XS-Edit - " + Version$, 227, 2, 27, 1, 1, 0
LINE (0, 0)-STEP(319, 11), 31, B

FOR X% = 0 TO 2
  Skriv Menu(X%, 0), X% * 65 + 10, 2, -1, 1, 1, 0
NEXT X%

SkrivMusePosition 0, 0
VisMus
END SUB

SUB MenuPunktValgt (Soejle%, MenuValg%)
SELECT CASE Soejle%
  CASE 0
    SELECT CASE MenuValg%

      CASE 0    'Ny tegning
        VisMus
        MouseRange 0, 0, 638, 198
        IF Billede.Beskidt = "T" THEN
          IF JaNejTryk("Ny tegning uden at gemme?") = 0 THEN EXIT SUB
        END IF
        GemMus
        FOR X% = 0 TO UBOUND(Sprite, 1) - 1
          FOR Y% = 0 TO UBOUND(Sprite, 2) - 1
            Sprite(X%, Y%) = 0
            TegnFelt X%, Y%, Sprite(X%, Y%)
        NEXT Y%, X%
        Billede.Beskidt = "F"

      CASE 1    'ben BSV
        VisMus
        MouseRange 0, 0, 638, 198
        IF Billede.Beskidt = "T" THEN
          IF JaNejTryk("ben uden at gemme nuvrende?") = 1 THEN
            HentBSV
          ELSE
            EXIT SUB
          END IF
        ELSE
          HentBSV
        END IF
      CASE 2    'ben BIN
        VisMus
        MouseRange 0, 0, 638, 198
        IF Billede.Beskidt = "T" THEN
          IF JaNejTryk("ben uden at gemme nuvrende?") = 1 THEN
            HentBin
          ELSE
            EXIT SUB
          END IF
        ELSE
          HentBin
        END IF
      CASE 3    'Gem BSV
        FilNavn$ = Indtast$("Hvad skal BSV-filen hedde?", "TEKST", RTRIM$(Billede.FilNavn))
        IF LEN(FilNavn$) THEN GemBSV FilNavn$
    
      CASE 4    'Gem BIN
        FilNavn$ = Indtast$("Hvad skal BIN-filen hedde?", "TEKST", RTRIM$(Billede.FilNavn))
        IF LEN(FilNavn$) THEN GemBIN FilNavn$
    
      CASE 5    'Gem maske
        FilNavn$ = Indtast$("Hvad skal MSK-filen hedde?", "TEKST", RTRIM$(Billede.FilNavn))
        IF LEN(FilNavn$) THEN GemMaske FilNavn$
      
      CASE 6    'Afslut
        VisMus
        MouseRange 0, 0, 638, 198
        IF JaNejTryk("Vil du slutte?") THEN
          SCREEN 0
          WIDTH 80
          COLOR 8
          PRINT "XS-EDIT Version " + Version$ + " - Jakob Krarup, 1998"
          COLOR 7
          END
        END IF
        EXIT SUB

    END SELECT
  CASE 1        'Rediger menuen
    SELECT CASE MenuValg%
      CASE 0    'Klip til i strrelse
      IF ValgtOmraade = "T" THEN
        Bredde% = Billede.Xop - Billede.Xned - 1
        Hoejde% = Billede.Yop - Billede.Yned - 1
        REDIM HuskeOmraade(Bredde%, Hoejde%) AS INTEGER
        FOR FeltX% = 0 TO Bredde% - 1
          FOR FeltY% = 0 TO Hoejde% - 1
            HuskeOmraade(FeltX%, FeltY%) = Sprite(Billede.Xned + FeltX% + 1, Billede.Yned + FeltY% + 1)
          NEXT FeltY%, FeltX%
      
        REDIM Sprite(Bredde%, Hoejde%) AS INTEGER

        FOR FeltX% = 0 TO Bredde% - 1
          FOR FeltY% = 0 TO Hoejde% - 1
            Sprite(FeltX%, FeltY%) = HuskeOmraade(FeltX%, FeltY%)
        NEXT FeltY%, FeltX%
        ValgtOmraade = "F"
        Billede.Xop = UBOUND(Sprite, 1)
        Billede.Yop = UBOUND(Sprite, 2)
        Billede.ForrigeXfelt = X%
        Billede.ForrigeYfelt = Y%
        LavSkaerm
      ELSE
        Besked "Vlg et omrde frst!", "", 33, 2
      END IF
    
      CASE 1    'Spejlvend
        Bredde% = UBOUND(Sprite, 1)
        HalvBredde% = Bredde% / 2
        FOR X% = 0 TO HalvBredde% - 1
          FOR Y% = 0 TO UBOUND(Sprite, 2)
            SWAP Sprite(X%, Y%), Sprite(Bredde% - X% - 1, Y%)
        NEXT Y%, X%
        LavSkaerm
   
      CASE 2    'Flyt
       IF ValgtOmraade = "T" THEN
         FlytValgtOmraade
       ELSE
         Besked "Vlg et omrde frst!", "", 33, 2
       END IF

      CASE 3    'bldgr
      Procent! = VAL(Indtast("Hvor mange procent skal billedet bldgres?", "TAL", "50"))
      IF Procent! < 1 OR Procent! > 100 THEN
        Besked "Ugyldig vrdi!", "Kun tal mellem 1% og 100%", 4, 3
        VisMus
        MouseRange 0, 0, 638, 198
        VentPaaMuseSlip
        EXIT SUB
      ELSE
      Procent! = Procent! / 100
      END IF
      Bredde% = UBOUND(Sprite, 1)
      Hoejde% = UBOUND(Sprite, 2)
      IF debug% THEN Besked STR$(Bredde%), STR$(Hoejde%), 1, 4
      DIM MidlertidigMatrice(0 TO Bredde% - 1, 0 TO Hoejde% - 1, 0 TO 2) AS STRING * 1
      FOR Nuance% = 0 TO 2      '0 = R, 1 = G, 2 = B
        FOR X% = 0 TO Bredde% - 1
          FOR Y% = 0 TO Hoejde% - 1
            CenterFelt% = Sprite(X%, Y%)
            Taeller% = 0
            AntalFelterFundet% = 0
            FOR DeltaX% = -1 TO 1
              FOR DeltaY% = -1 TO 1
                XDerCheckes% = X% + DeltaX%
                YDerCheckes% = Y% + DeltaY%
                Felt% = CheckFelt(XDerCheckes%, YDerCheckes%)
                IF debug% THEN Besked "Vi checker felt:", STR$(XDerCheckes%) + "," + STR$(YDerCheckes%), 1, 1
                IF Felt% > -1 THEN
                  AntalFelterFundet% = AntalFelterFundet% + 1
                  IF Nuance% = 0 THEN
                    Taeller% = Taeller% + ASC(Farve(Felt%).R)
                  ELSEIF Nuance% = 1 THEN
                    Taeller% = Taeller% + ASC(Farve(Felt%).G)
                  ELSEIF Nuance% = 2 THEN
                    Taeller% = Taeller% + ASC(Farve(Felt%).B)
                  END IF
                END IF
          NEXT DeltaY%, DeltaX%
          'Vi finder gennemsnitsvrdien af alle felterne
          IF debug% THEN Besked "der blev talt" + STR$(AntalFelterFundet%) + "felter", "X: " + STR$(X%) + "Y: " + STR$(Y%), 1, 2
          Taeller% = Taeller% / AntalFelterFundet%
          IF debug% THEN Besked "Gennemsnitsvrdien er", STR$(Taeller%), 1, 3

          IF Nuance% = 0 THEN
            NuanceForskel% = Taeller% - ASC(Farve(CenterFelt%).R)
            IF debug% THEN Besked "Nuanceforskel gnmsn og center - rd", STR$(NuanceForskel%), 1, 2
            MidlertidigMatrice(X%, Y%, Nuance%) = CHR$(ASC(Farve(CenterFelt%).R) + Procent! * NuanceForskel%)
            IF debug% THEN Besked "Der stod:", STR$(ASC(Farve(CenterFelt%).R)), 1, 2
            IF debug% THEN Besked "Vi skriver", STR$(ASC(MidlertidigMatrice(X%, Y%, Nuance%))), 1, 2
          ELSEIF Nuance% = 1 THEN
            NuanceForskel% = Taeller% - ASC(Farve(CenterFelt%).G)
            IF debug% THEN Besked "Nuanceforskel gnmsn og center - grn", STR$(NuanceForskel%), 1, 2
            MidlertidigMatrice(X%, Y%, Nuance%) = CHR$(ASC(Farve(CenterFelt%).G) + Procent! * NuanceForskel%)
            IF debug% THEN Besked "Der stod:", STR$(ASC(Farve(CenterFelt%).G)), 1, 2
            IF debug% THEN Besked "Vi skriver", STR$(ASC(MidlertidigMatrice(X%, Y%, Nuance%))), 1, 2
          ELSEIF Nuance% = 2 THEN
            NuanceForskel% = Taeller% - ASC(Farve(CenterFelt%).B)
            IF debug% THEN Besked "Nuanceforskel gnmsn og center - bl", STR$(NuanceForskel%), 1, 2
            MidlertidigMatrice(X%, Y%, Nuance%) = CHR$(ASC(Farve(CenterFelt%).B) + Procent! * NuanceForskel%)
            IF debug% THEN Besked "Der stod:", STR$(ASC(Farve(CenterFelt%).B)), 1, 2
            IF debug% THEN Besked "Vi skriver", STR$(ASC(MidlertidigMatrice(X%, Y%, Nuance%))), 1, 2
          END IF
        NEXT Y%, X%
      NEXT Nuance%

    FOR X% = 0 TO Bredde% - 1
      FOR Y% = 0 TO Hoejde% - 1
        Roed$ = STR$(ASC(MidlertidigMatrice(X%, Y%, 0)))
        Groen$ = STR$(ASC(MidlertidigMatrice(X%, Y%, 1)))
        Blaa$ = STR$(ASC(MidlertidigMatrice(X%, Y%, 2)))
        Sprite(X%, Y%) = NaermesteFarve(ASC(MidlertidigMatrice(X%, Y%, 0)), ASC(MidlertidigMatrice(X%, Y%, 1)), ASC(MidlertidigMatrice(X%, Y%, 2)))
        IF debug% THEN Besked "RGB vrdier", Roed$ + " " + Groen$ + " " + Blaa$, 1, 2
        TegnFelt X%, Y%, Sprite(X%, Y%)
    NEXT Y%, X%
    END SELECT

  CASE 2        'Strrelse menuen

    SELECT CASE MenuValg%
      CASE 0    '10*10 felter
        Nybredde% = 10
        NyHoejde% = 10
      CASE 1    '20*20 felter
        Nybredde% = 20
        NyHoejde% = 20

      CASE 2    '50*50 felter
        Nybredde% = 50
        NyHoejde% = 50
      CASE 3    '75*75 felter
        Nybredde% = 75
        NyHoejde% = 75
      CASE 4    '100*100 felter
        Nybredde% = 100
        NyHoejde% = 100
      CASE 5    'selvvalgt
        Nybredde% = VAL(Indtast("Hvad skal ny bredde vre", "TEKST", "10"))
        IF Nybredde% = 0 THEN
          VisMus
          MouseRange 0, 0, 638, 198
          EXIT SUB
        ELSEIF Nybredde% > 100 THEN
          Besked "For bredt billede!", "Maximum bredde er 100 pixels", 4, 3
          VisMus
          MouseRange 0, 0, 638, 198
          EXIT SUB
        END IF
        NyHoejde% = VAL(Indtast("Hvad skal ny hjde vre", "TEKST", "10"))
        IF NyHoejde% = 0 THEN
          VisMus
          MouseRange 0, 0, 638, 198
          EXIT SUB
        ELSEIF NyHoejde% > 100 THEN
          Besked "For hjt billede!", "Maximum hjde er 100 pixels", 4, 3
          VisMus
          MouseRange 0, 0, 638, 198
          EXIT SUB
        END IF
        

    END SELECT
    NyStoerrelse Nybredde%, NyHoejde%
    
  
END SELECT
VisMus
MouseRange 0, 0, 638, 198
VentPaaMuseSlip
EXIT SUB

END SUB

SUB MenuTryk (Soejle%)

IF Soejle% = 0 THEN     'Husker hvor mange menulinier der skal rulle ned
  AntalRaekker% = 7
ELSEIF Soejle% = 1 THEN
  AntalRaekker% = 4
ELSEIF Soejle% = 2 THEN
  AntalRaekker% = 6
END IF


DIM MenuGetter(5100) AS INTEGER
GemMus
GET (Soejle% * 65 + 10, 0)-STEP(60, 85), MenuGetter

LINE (Soejle% * 65 + 10, 12)-STEP(60, 10 * (AntalRaekker%)), 28, BF

FOR Raekke% = 1 TO AntalRaekker%
  Skriv Menu(Soejle%, Raekke%), Soejle% * 65 + 10, 14 + 10 * (Raekke% - 1), -1, 1, 1, 0
NEXT Raekke%

MinY% = 12
MaxY% = 12 + 10 * (AntalRaekker%)
MinX% = (Soejle% * 65 + 10) * 2
MaxX% = (Soejle% * 65 + 10 + 60) * 2
LINE (Soejle% * 65 + 11, 13 + MenuValg% * 10)-STEP(58, 8), 26, BF
Skriv Menu(Soejle%, MenuValg% + 1), Soejle% * 65 + 10, 14 + 10 * (MenuValg%), 255, 1, 0, 0
VisMus
MousePut Soejle% * 130 + 60, 14
MouseRange MinX%, MinY%, MaxX%, MaxY%

DO      'Venter til musen ikke lngere er trykket
  HentMuseStatus LB%, RB%, X%, Y%
LOOP WHILE LB% = -1


DO
  HentMuseStatus LB%, RB%, X%, Y%
  IF LB% = -1 THEN
    GemMus
    PUT (Soejle% * 65 + 10, 0), MenuGetter, PSET
    MenuPunktValgt Soejle%, MenuValg%
    VisMus
    MouseRange 0, 0, 638, 198
    VentPaaMuseSlip
    EXIT SUB
  END IF
  MenuValg% = (Ymus% - 13) \ 10
  IF MenuValg% <> GamleMenuValg% THEN
    GemMus
    LINE (Soejle% * 65 + 11, 13 + GamleMenuValg% * 10)-STEP(58, 8), 28, BF
    Skriv Menu(Soejle%, GamleMenuValg% + 1), Soejle% * 65 + 10, 14 + 10 * (GamleMenuValg%), -1, 1, 1, 0
    LINE (Soejle% * 65 + 11, 13 + MenuValg% * 10)-STEP(58, 8), 26, BF
    Skriv Menu(Soejle%, MenuValg% + 1), Soejle% * 65 + 10, 14 + 10 * (MenuValg%), 255, 1, 0, 0
    GamleMenuValg% = MenuValg%
    VisMus
  END IF

LOOP WHILE INKEY$ <> CHR$(27) AND RB% = 0

GemMus
PUT (Soejle% * 65 + 10, 0), MenuGetter, PSET
VisMus
MouseRange 0, 0, 638, 198
VentPaaMuseSlip




END SUB

DEFLNG A-Z
SUB MouseDriver (ax%, bx%, cx%, dx%)
  DEF SEG = VARSEG(Mouse$)
  Mouse% = SADD(Mouse$)
  CALL Absolute(ax%, bx%, cx%, dx%, Mouse%)
END SUB

FUNCTION MouseInit%
  ax% = 0
  MouseDriver ax%, 0, 0, 0
  MouseInit% = ax%
END FUNCTION

DEFSNG A-Z
SUB MousePut (X%, Y%)
  ax% = 4
  cx% = X%
  dx% = Y%
  MouseDriver ax%, 0, cx%, dx%
END SUB

'
SUB MouseRange (X1%, Y1%, X2%, Y2%)
  ax% = 7
  cx% = X1%
  dx% = X2%
MouseDriver ax%, 0, cx%, dx%
  ax% = 8
  cx% = Y1%
  dx% = Y2%
  MouseDriver ax%, 0, cx%, dx%
END SUB

FUNCTION NaermesteFarve (Roed%, Groen%, Blaa%)

'Denne sub returnerer den nrmeste farve til den der sendes med

FarveForskel% = 1000
NaermesteFarve = 0
FOR FarveChecker% = 0 TO 255
  RoedForskel% = ASC(Farve(FarveChecker%).R) - Roed%
  GroenForskel% = ASC(Farve(FarveChecker%).G) - Groen%
  BlaaForskel% = ASC(Farve(FarveChecker%).B) - Blaa%
  VaegtetForskel = RoedForskel% ^ 2 + GroenForskel% ^ 2 + BlaaForskel% ^ 2
  IF VaegtetForskel < FarveForskel% THEN
    FarveForskel% = VaegtetForskel
    NaermesteFarve = FarveChecker%
  END IF
NEXT FarveChecker%

END FUNCTION

SUB NyStoerrelse (Nybredde%, NyHoejde%)

DIM OverfoerselsBredde%, OverfoerselsHoejde%

REDIM HuskeOmraade(UBOUND(Sprite, 1), UBOUND(Sprite, 2)) AS INTEGER
FOR X% = 0 TO UBOUND(Sprite, 1)
  FOR Y% = 0 TO UBOUND(Sprite, 2)
    HuskeOmraade(X%, Y%) = Sprite(X%, Y%)
NEXT Y%, X%

IF Nybredde% >= UBOUND(Sprite, 1) THEN
  OverfoerselsBredde% = UBOUND(Sprite, 1)
ELSE
  OverfoerselsBredde% = Nybredde%
END IF

IF NyHoejde% >= UBOUND(Sprite, 2) THEN
  OverfoerselsHoejde% = UBOUND(Sprite, 2)
ELSE
  OverfoerselsHoejde% = NyHoejde%
END IF

REDIM Sprite(Nybredde%, NyHoejde%) AS INTEGER

FOR X% = 0 TO OverfoerselsBredde% - 1
  FOR Y% = 0 TO OverfoerselsHoejde% - 1
    Sprite(X%, Y%) = HuskeOmraade(X%, Y%)
NEXT Y%, X%
BeregnFliser
LavSkaerm


END SUB

SUB OpdaterValgtFarve (FarveValgt%)

IF FarveValgt% = mus.Farve THEN EXIT SUB

GemMus

'Tegner frst den gamle valgte kasse over
X% = mus.Farve MOD 64
Y% = mus.Farve \ 64
LINE (32 + X% * 4, 180 + Y% * 4)-STEP(3, 3), mus.Farve, BF

mus.GamleFarve = mus.Farve
mus.Farve = FarveValgt%

X% = mus.Farve MOD 64
Y% = mus.Farve \ 64

LINE (32 + X% * 4, 180 + Y% * 4)-STEP(3, 3), 255, B   'ValgtFarve i paletten

LINE (175, 140)-STEP(20, 20), mus.Farve, BF       'Farvefelt

'Til farvetallet
LINE (175, 165)-STEP(20, 8), 31, BF

Skriv STR$(mus.Farve), 171, 166, -1, 1, 1, 0

'Kasse rundt om
LINE (199, 143)-STEP(90, 10), 29, B
LINE (229, 143)-STEP(30, 10), 29, B
'Baggrundskasser
LINE (200, 144)-STEP(28, 8), 31, BF
LINE (230, 144)-STEP(28, 8), 31, BF
LINE (260, 144)-STEP(28, 8), 31, BF
Skriv "R:" + LTRIM$(STR$(ASC(Farve(mus.Farve).R))), 201, 145, 150, 1, 1, 0
Skriv "G:" + LTRIM$(STR$(ASC(Farve(mus.Farve).G))), 231, 145, 150, 1, 1, 0
Skriv "B:" + LTRIM$(STR$(ASC(Farve(mus.Farve).B))), 261, 145, 150, 1, 1, 0

VisMus
END SUB

SUB Skriv (Tekst AS STRING, X%, Y%, FontFarve%, Stoerrelse%, Skygge%, tid!)

DIM AscA6PlusX AS INTEGER, A6 AS INTEGER

SkaermBreddeIPixels% = 320

WHILE LEN(INKEY$): WEND 'Rydder tastaturbufferen

'hvis X = -1 s skal der centreres
IF X% = -1 THEN X% = (SkaermBreddeIPixels% - LEN(Tekst) * Stoerrelse% * 6) / 2

'Hvis fontfarve% = -1 s skrives der med disse farver

FOR Y = 0 TO 7
  FontFarve(Y) = 90 + Y * 3
NEXT Y

SkrivFarve% = FontFarve%

FOR bogstav = 1 TO LEN(Tekst)
   a = ASC(MID$(Tekst, bogstav, 1)) - 33
   A6 = a * 6
   IF a >= 0 AND a <= 140 THEN
     FOR X = 0 TO 5
        AscA6PlusX = ASC(Alfabet(A6 + X))
        Xkoordinat% = X% + (bogstav - 1) * 6 + X + 1
        FOR Y = 0 TO 7
          IF Stoerrelse% = 1 THEN
            IF FontFarve% = -1 THEN
              IF AscA6PlusX AND Tabel(Y) THEN PSET (Xkoordinat%, Y% + Y), FontFarve(Y)
            ELSE
              IF AscA6PlusX AND Tabel(Y) THEN PSET (Xkoordinat%, Y% + Y), SkrivFarve%
            END IF
            IF Skygge% THEN IF AscA6PlusX AND Tabel(Y) THEN PSET (Xkoordinat% + 1, Y% + Y + 1), 0
          ELSE
            IF FontFarve% = -1 THEN
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN LINE (X% + ((bogstav - 1) * 6 + X) * Stoerrelse%, Y% + Y * Stoerrelse%)-STEP(Stoerrelse% - 1, Stoerrelse% - 1), FontFarve(Y), BF
            ELSE
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN LINE (X% + ((bogstav - 1) * 6 + X) * Stoerrelse%, Y% + Y * Stoerrelse%)-STEP(Stoerrelse% - 1, Stoerrelse% - 1), SkrivFarve%, BF
            END IF
            IF Skygge% THEN IF AscA6PlusX AND Tabel(Y) THEN LINE (X% + ((bogstav - 1) * 6 + X + 1) * Stoerrelse%, Y% + (Y + 1) * Stoerrelse%)-STEP(Stoerrelse% - 1, Stoerrelse% - 1), 0, BF
          END IF
        NEXT Y
      NEXT X
  END IF
NEXT bogstav


  starttid! = TIMER
  DO
  LOOP WHILE TIMER - starttid! < tid! AND LEN(INKEY$) = 0
  EXIT SUB

END SUB

SUB SkrivMusePosition (X%, Y%)

LINE (199, 133)-STEP(70, 10), 29, B
LINE (199, 133)-STEP(35, 10), 29, B

LINE (200, 134)-STEP(33, 8), 31, BF
Skriv "X:" + STR$(X%), 202, 135, 150, 1, 1, 0

LINE (235, 134)-STEP(33, 8), 31, BF
Skriv "Y:" + STR$(Y%), 237, 135, 150, 1, 1, 0


END SUB

SUB TegnFelt (X%, Y%, Farve%)
 
 
LINE (X% * Billede.Feltstr + Billede.VenstreMargin, Y% * Billede.Feltstr + Billede.TopMargin)-STEP(Billede.Feltstr - 1, Billede.Feltstr - 1), Farve%, BF
PSET (205 + X%, 25 + Y%), Farve%

IF Billede.Fliser = "T" THEN
 
  GET (205, 25)-STEP(UBOUND(Sprite, 1) - 1, UBOUND(Sprite, 2) - 1), knap%(0)

  FOR Xcount% = 0 TO Billede.AntaliBredden% - 1
    FOR Ycount% = 0 TO Billede.AntaliHoejden% - 1
      PUT (205 - (Billede.SamletBredde% / 2) + UBOUND(Sprite, 2) * Xcount%, (25 - (Billede.SamletHoejde% / 2) + UBOUND(Sprite, 1) * Ycount%)), knap%(0), PSET
  NEXT Ycount%, Xcount%
END IF

END SUB

SUB TegnValgtOmraade (X%, Y%)   'De nuvrende musekoordinater medsendes

GemMus
FOR XFelt% = Billede.Xned TO Billede.ForrigeXfelt
  FOR YFelt% = Billede.Yned TO Billede.ForrigeYfelt
   IF XFelt% = Billede.Xned OR XFelt% = Billede.ForrigeXfelt OR YFelt% = Billede.Yned OR YFelt% = Billede.ForrigeYfelt THEN
     IF Billede.ForrigeXfelt = X% AND Billede.ForrigeYfelt = Y% THEN
       IF AktivtVaerktoej = 3 THEN
         TegnFelt XFelt%, YFelt%, (RND * 5) * 2 + 90
       ELSE
         TegnFelt XFelt%, YFelt%, mus.Farve
       END IF
     ELSE
       TegnFelt XFelt%, YFelt%, Sprite(XFelt%, YFelt%)
     END IF
   END IF
NEXT YFelt%, XFelt%
VisMus
END SUB

SUB VentPaaMuseSlip

DO
  HentMuseStatus LB%, RB%, X%, Y%
LOOP WHILE LB% OR RB%

END SUB

SUB VisBSVFil (FilNavn$)

DEF SEG = &HA000        'Indstiller segmentet til skrmhukommelsen

SCREEN 13

FOR Col = 0 TO 255      'Frst mrklgges alle farver
  OUT &H3C8, Col
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
NEXT Col

BLOAD FilNavn$, 0       'Putter filen i skrmhukommelsen

FilFornavn$ = MID$(FilNavn$, 1, LEN(FilNavn$) - 4)      'Finder filens fornavn
FilNavn$ = FilFornavn$ + ".PAL"

OPEN FilNavn$ FOR INPUT AS #1  'For at f fejlbesked hvis noget gr galt
CLOSE #1

OPEN FilNavn$ FOR BINARY AS #1
  FOR Col = 0 TO 255
    GET #1, , Farve(Col).R
    GET #1, , Farve(Col).G
    GET #1, , Farve(Col).B
  NEXT Col
CLOSE #1

FOR Col = 0 TO 255      'S sttes der farve p!
  OUT &H3C8, Col
  OUT &H3C9, ASC(Farve(Col).R)
  OUT &H3C9, ASC(Farve(Col).G)
  OUT &H3C9, ASC(Farve(Col).B)
NEXT Col

tid = TIMER

WHILE INKEY$ <> "": WEND

DO
  HentMuseStatus LB%, RB%, X%, Y%
  IF RB% OR LB% OR INKEY$ <> "" THEN EXIT DO
LOOP WHILE TIMER - tid < 3


END SUB

DEFLNG A-Z
SUB VisMus
  ax% = 1
  MouseDriver ax%, 0, 0, 0
END SUB

DEFSNG A-Z
SUB VisSomFelter

DIM Getter%(104 * 104)
GET (109, 49)-STEP(101, 101), Getter%(0)


PicWidth& = UBOUND(Sprite, 1)
PicHeight& = UBOUND(Sprite, 2)

LINE (109, 49)-STEP(101, 101), 28, BF
LINE (109, 49)-STEP(101, 101), 0, B

AntaliHoejden% = INT(100 / PicHeight&)
AntaliBredden% = INT(100 / PicWidth&)
SamletBredde% = PicWidth& * AntaliBredden%
SamletHoejde% = PicHeight& * AntaliHoejden%

GET (205, 25)-STEP(PicWidth& - 1, PicHeight& - 1), knap%(0)

FOR Xcount% = 0 TO AntaliBredden% - 1
  FOR Ycount% = 0 TO AntaliHoejden% - 1
    PUT (160 - (SamletBredde% / 2) + PicWidth& * Xcount%, (100 - (SamletHoejde% / 2) + PicHeight& * Ycount%)), knap%(0), PSET
NEXT Ycount%, Xcount%


VentPaaMuseSlip
WHILE INKEY$ <> "": WEND

DO
  HentMuseStatus LB%, RB%, xMouse%, yMouse%
  IF LB% OR RB% THEN EXIT DO
LOOP WHILE INKEY$ = ""
PUT (109, 49), Getter%(0), PSET
VentPaaMuseSlip
END SUB

